## diffname gnot/errno.h 1990/03091
## diff -e /dev/null /n/bootesdump/1990/03091/sys/src/9/68020/errno.h
0a
enum{
	Enevermind,	/* never mind */
	Enofd,		/* no free file descriptors */
	Ebadfd,		/* fd out of range or not open */
	Ebadusefd,	/* inappropriate use of fd */
	Ebadarg,	/* bad arg in system call */
	Enonexist,	/* file does not exist */
	Efilename,	/* file name syntax */
	Ebadchar,	/* bad character in file name */
	Ebadsharp,	/* unknown device in # filename */
	Ebadexec,	/* a.out header invalid */
	Eioload,	/* i/o error in demand load */
	Eperm,		/* permission denied */
	Enotdir,	/* not a directory */
	Enochild,	/* no living children */
	Enoseg,		/* no free segments */
	Ebadmount,	/* inconsistent mount */
	Enomount,	/* mount table full */
	Enomntdev,	/* no free mount devices */
	Eshutdown,	/* mounted device shut down */
	Einuse,		/* device or object already in use */
	Eio,		/* i/o error */
	Eisdir,		/* file is a directory */
	Ebaddirread,	/* directory read not quantized */
	Esegaddr,	/* illegal segment addresses or size */
	Enoenv,		/* no free environment resources */
	Eprocdied,	/* process exited */
	Enocreate,	/* mounted directory forbids creation */
	Enotunion,	/* attempt to union with non-mounted directory */
	Emount,		/* inconsistent mount */
	Enosrv,		/* no free server slots */
	Enoqueue,	/* no free stream queues */
	Ebadld,		/* illegal line discipline */
	Enostream,	/* no free stream heads */
	Etoobig,	/* read or write too large */
	Etoosmall,	/* read or write too small */
	Ehungup,	/* write to hungup stream */
	Ebadnet,	/* illegal network address */
	Enoifc,		/* no free nonet interface slots */
	Enodev,		/* no free devices */
	Ebadctl,	/* bad process control request */
	Enonote,	/* note overflow */
	Eintr,		/* interrupted */
	Egreg,		/* it's all greg's fault */
};
.
## diffname gnot/errno.h 1990/0312
## diff -e /n/bootesdump/1990/03091/sys/src/9/68020/errno.h /n/bootesdump/1990/0312/sys/src/9/68020/errno.h
43a
	Edestbusy,	/* datakit destination busy */
	Enetbusy,	/* datakit controller busy */
	Edestotl,	/* datakit destination out to lunch */
	Enetotl,	/* datakit controller out to lunch */
	Erejected,	/* datakit destination rejected call */
.
39c
	Enoifc,		/* no free interface slots */
.
## diffname gnot/errno.h 1990/0324
## diff -e /n/bootesdump/1990/0312/sys/src/9/68020/errno.h /n/bootesdump/1990/0324/sys/src/9/68020/errno.h
48a
	Ebadblt,	/* bad bitblt or bitctl request */
.
## diffname gnot/errno.h 1990/0327
## diff -e /n/bootesdump/1990/0324/sys/src/9/68020/errno.h /n/bootesdump/1990/0327/sys/src/9/68020/errno.h
49c
	Ebadblt,	/* bad bitblt or bitmap request */
	Enobitmap,	/* out of bitmap descriptors */
	Enobitstore,	/* out of bitmap storage */
.
## diffname gnot/errno.h 1990/0329
## diff -e /n/bootesdump/1990/0327/sys/src/9/68020/errno.h /n/bootesdump/1990/0329/sys/src/9/68020/errno.h
51a
	Ebadbitmap,	/* unallocated bitmap */
.
## diffname gnot/errno.h 1990/05313
## diff -e /n/bootesdump/1990/0329/sys/src/9/68020/errno.h /n/bootesdump/1990/05313/sys/src/9/68020/errno.h
52a
	Eshortmsg,	/* short message */
	Ebadmsg,	/* format error or mismatch in message */
.
## diffname gnot/errno.h 1990/0623
## diff -e /n/bootesdump/1990/05313/sys/src/9/68020/errno.h /n/bootesdump/1990/0623/sys/src/9/68020/errno.h
54a
	Enofont,	/* out of font descriptors */
.
## diffname gnot/errno.h 1990/0703
## diff -e /n/bootesdump/1990/0623/sys/src/9/68020/errno.h /n/bootesdump/1990/0703/sys/src/9/68020/errno.h
54a
	Ebadcnt,	/* read count greater than requested */
.
## diffname gnot/errno.h 1990/0725
## diff -e /n/bootesdump/1990/0703/sys/src/9/68020/errno.h /n/bootesdump/1990/0725/sys/src/9/68020/errno.h
52a
	Ebadfont,	/* unallocated font */
.
## diffname gnot/errno.h 1990/0726
## diff -e /n/bootesdump/1990/0725/sys/src/9/68020/errno.h /n/bootesdump/1990/0726/sys/src/9/68020/errno.h
53d
## diffname gnot/errno.h 1990/0728
## diff -e /n/bootesdump/1990/0726/sys/src/9/68020/errno.h /n/bootesdump/1990/0728/sys/src/9/68020/errno.h
52a
	Ebadfont,	/* unallocated font */
.
## diffname gnot/errno.h 1990/0802
## diff -e /n/bootesdump/1990/0728/sys/src/9/68020/errno.h /n/bootesdump/1990/0802/sys/src/9/68020/errno.h
57a
	Enovmem,	/* virtual memory allocation failed */
.
## diffname gnot/errno.h 1990/0830
## diff -e /n/bootesdump/1990/0802/sys/src/9/68020/errno.h /n/bootesdump/1990/0830/sys/src/9/68020/errno.h
59c
	Egreg,		/* rob made me do it */
.
## diffname gnot/errno.h 1990/0907
## diff -e /n/bootesdump/1990/0830/sys/src/9/68020/errno.h /n/bootesdump/1990/0907/sys/src/9/68020/errno.h
59c
	Egreg,		/* ken hasn't implemented datakit */
.
## diffname gnot/errno.h 1990/0911
## diff -e /n/bootesdump/1990/0907/sys/src/9/68020/errno.h /n/bootesdump/1990/0911/sys/src/9/68020/errno.h
58a
	Enoasync,	/* out of async stream modules */
.
## diffname gnot/errno.h 1990/1009
## diff -e /n/bootesdump/1990/0911/sys/src/9/68020/errno.h /n/bootesdump/1990/1009/sys/src/9/68020/errno.h
59a
	Enopipe,	/* out of pipes */
.
41c
	Ebadctl,	/* bad process or stream control request */
.
39c
	Enoifc,		/* bad interface or no free interface slots */
.
## diffname gnot/errno.h 1990/1110
## diff -e /n/bootesdump/1990/1009/sys/src/9/68020/errno.h /n/bootesdump/1990/1110/sys/src/9/68020/errno.h
60a
	Enofilsys,	/* out of filsys resources */
.
## diffname gnot/errno.h 1990/1127
## diff -e /n/bootesdump/1990/1110/sys/src/9/68020/errno.h /n/bootesdump/1990/1127/sys/src/9/68020/errno.h
62c
	Egreg,		/* ken has implemented datakit */
.
## diffname gnot/errno.h 1991/0319
## diff -e /n/bootesdump/1991/0201/sys/src/9/68020/errno.h /n/bootesdump/1991/0319/sys/src/9/gnot/errno.h
61a
	Eisstream,	/* seek on a stream */
.
## diffname gnot/errno.h 1991/0724
## diff -e /n/bootesdump/1991/0319/sys/src/9/gnot/errno.h /n/bootesdump/1991/0724/sys/src/9/gnot/errno.h
2c
	Enoerror,	/* no error */
.
## diffname gnot/errno.h 1992/0111 # deleted
## diff -e /n/bootesdump/1991/0724/sys/src/9/gnot/errno.h /n/bootesdump/1992/0111/sys/src/9/gnot/errno.h
1,64d
