## diffname pc/segment.h 1991/0711
## diff -e /dev/null /n/bootesdump/1991/0711/sys/src/9/safari/segment.h
0a
/*
 * Attach segment types
 */

typedef struct Physseg Physseg;
struct Physseg
{
	ulong	attr;			/* Segment attributes */
	char	*name;			/* Attach name */
	ulong	pa;			/* Physical address */
	ulong	size;			/* Maximum segment size in pages */
	Page	*(*pgalloc)(ulong);	/* Allocation if we need it */
	void	(*pgfree)(Page*);
}physseg[] = {
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	&snewpage, 	&putpage },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	&snewpage, 	&putpage },
	{ SG_PHYSICAL,	"kmem",		KZERO,	SEGMAXSIZE,	0,		0 	},
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	&snewpage,	&putpage },
	{ 0,		0,		0,	0,		0,		0 	},
};
.
## diffname pc/segment.h 1992/0711
## diff -e /n/bootesdump/1991/0711/sys/src/9/safari/segment.h /n/bootesdump/1992/0711/sys/src/9/safari/segment.h
18c
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	snewpage,	putpage },
.
15,16c
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	snewpage, 	putpage },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	snewpage, 	putpage },
.
## diffname pc/segment.h 1993/0115
## diff -e /n/bootesdump/1992/0808/sys/src/9/safari/segment.h /n/bootesdump/1993/0115/sys/src/9/pc/segment.h
17c
	{ SG_PHYSICAL,	"pcmem",	PCMEM,	64*1024,	0,		0,	},
.
4a
#define PCMEM (KZERO|0xd0000)

.
## diffname pc/segment.h 1993/0120
## diff -e /n/bootesdump/1993/0115/sys/src/9/pc/segment.h /n/bootesdump/1993/0120/sys/src/9/pc/segment.h
17,21c
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	0, 	0 },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 	0 },
	{ SG_PHYSICAL,	"dseg",		0xd0000, 64*1024,	dsegalloc,	dsegfree, },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0,	0 },
	{ 0,		0,		0,	0,		0,	0 },
.
14c
	Page	*(*pgalloc)(Segment*, ulong);	/* Allocation if we need it */
.
5,6d
## diffname pc/segment.h 1993/0210
## diff -e /n/bootesdump/1993/0120/sys/src/9/pc/segment.h /n/bootesdump/1993/0210/sys/src/9/pc/segment.h
17c
	{ SG_PHYSICAL,	"dseg",		0xd0000, 64*1024,	0,	0 },
.
8,14d
5,6c
Physseg physseg[] =
.
## diffname pc/segment.h 1997/0613
## diff -e /n/bootesdump/1993/0210/sys/src/9/pc/segment.h /n/emeliedump/1997/0613/sys/src/brazil/pc/segment.h
8a
	{ SG_PHYSICAL,	"aseg",		0xa0000, 64*1024,	0,	0 },
.
## diffname pc/segment.h 1997/0808
## diff -e /n/emeliedump/1997/0613/sys/src/brazil/pc/segment.h /n/emeliedump/1997/0808/sys/src/brazil/pc/segment.h
9d
## diffname pc/segment.h 1998/0325
## diff -e /n/emeliedump/1997/0808/sys/src/brazil/pc/segment.h /n/emeliedump/1998/0325/sys/src/brazil/pc/segment.h
10a
	{ SG_PHYSICAL,	"pcivctl",	0,	16*1024,	0, 0 },
.
## diffname pc/segment.h 1998/0326
## diff -e /n/emeliedump/1998/0325/sys/src/brazil/pc/segment.h /n/emeliedump/1998/0326/sys/src/brazil/pc/segment.h
11d
9d
4,7c
static Physseg physseg[10] = {
.
## diffname pc/segment.h 2001/0424 # deleted
## diff -e /n/emeliedump/1998/0326/sys/src/brazil/pc/segment.h /n/emeliedump/2001/0424/sys/src/9/pc/segment.h
1,8d
