## diffname port/systab.h 1991/0731
## diff -e /dev/null /n/bootesdump/1991/0731/sys/src/9/port/systab.h
0a
#undef	CHDIR	/* BUG */
#include "/sys/src/libc/9syscall/sys.h"

typedef long Syscall(ulong*);
Syscall sysbind, sysbrk_, syschdir, sysclose, syscreate, sysdeath;
Syscall	sysdup, syserrstr, sysexec, sysexits, sysfork, sysforkpgrp;
Syscall	sysfstat, sysfwstat, sysgetpid, sysmount, sysnoted;
Syscall	sysnotify, sysopen, syspipe, sysr1, sysread, sysremove, sysseek;
Syscall syssleep, sysstat, syswait, syswrite, syswstat, sysalarm, syssegbrk;
Syscall syssegattach, syssegdetach, syssegfree, syssegflush;

Syscall *systab[]={
	[SYSR1]		sysr1,
	[ERRSTR]	syserrstr,
	[BIND]		sysbind,
	[CHDIR]		syschdir,
	[CLOSE]		sysclose,
	[DUP]		sysdup,
	[ALARM]		sysalarm,
	[EXEC]		sysexec,
	[EXITS]		sysexits,
	[FORK]		sysfork,
	[FORKPGRP]	sysforkpgrp,
	[FSTAT]		sysfstat,
	[SEGBRK]	syssegbrk,
	[MOUNT]		sysmount,
	[OPEN]		sysopen,
	[READ]		sysread,
	[SEEK]		sysseek,
	[SLEEP]		syssleep,
	[STAT]		sysstat,
	[WAIT]		syswait,
	[WRITE]		syswrite,
	[PIPE]		syspipe,
	[CREATE]	syscreate,
	[___USERSTR___]	sysdeath,
	[BRK_]		sysbrk_,
	[REMOVE]	sysremove,
	[WSTAT]		syswstat,
	[FWSTAT]	sysfwstat,
	[NOTIFY]	sysnotify,
	[NOTED]		sysnoted,
	[SEGATTACH]	syssegattach,
	[SEGDETACH]	syssegdetach,
	[SEGFREE]	syssegfree,
	[SEGFLUSH]	syssegflush,
};
.
## diffname port/systab.h 1991/0806
## diff -e /n/bootesdump/1991/0731/sys/src/9/port/systab.h /n/bootesdump/1991/0806/sys/src/9/port/systab.h
46a
	[RENDEZVOUS]	sysrendezvous,
.
10a
Syscall sysrendezvous;
.
## diffname port/systab.h 1991/0807
## diff -e /n/bootesdump/1991/0806/sys/src/9/port/systab.h /n/bootesdump/1991/0807/sys/src/9/port/systab.h
37c
	[RFORK]		sysrfork,
.
11c
Syscall sysrendezvous, sysrfork;
.
## diffname port/systab.h 1991/0926
## diff -e /n/bootesdump/1991/0807/sys/src/9/port/systab.h /n/bootesdump/1991/0926/sys/src/9/port/systab.h
49a

char *sysctab[]={
	[SYSR1]		"Running",
	[ERRSTR]	"Errstr",
	[BIND]		"Bind",
	[CHDIR]		"Chdir",
	[CLOSE]		"Close",
	[DUP]		"Dup",
	[ALARM]		"Alarm",
	[EXEC]		"Exec",
	[EXITS]		"Exits",
	[FORK]		"Fork",
	[FORKPGRP]	"Forkpgrp",
	[FSTAT]		"Fstat",
	[SEGBRK]	"Segbrk",
	[MOUNT]		"Mount",
	[OPEN]		"Open",
	[READ]		"Read",
	[SEEK]		"Seek",
	[SLEEP]		"Sleep",
	[STAT]		"Stat",
	[WAIT]		"Wait",
	[WRITE]		"Write",
	[PIPE]		"Pipe",
	[CREATE]	"Create",
	[RFORK]		"Rfork",
	[BRK_]		"Brk",
	[REMOVE]	"Remove",
	[WSTAT]		"Wstat",
	[FWSTAT]	"Fwstat",
	[NOTIFY]	"Notify",
	[NOTED]		"Noted",
	[SEGATTACH]	"Segattach",
	[SEGDETACH]	"Segdetach",
	[SEGFREE]	"Segfree",
	[SEGFLUSH]	"Segflush",
	[RENDEZVOUS]	"Rendez",
};
.
## diffname port/systab.h 1991/1011
## diff -e /n/bootesdump/1991/0926/sys/src/9/port/systab.h /n/bootesdump/1991/1011/sys/src/9/port/systab.h
86a
	[UNMOUNT]	"Unmount",
.
48a
	[UNMOUNT]	sysunmount,
.
11c
Syscall sysrendezvous, sysrfork, sysunmount;
.
## diffname port/systab.h 1991/1105
## diff -e /n/bootesdump/1991/1011/sys/src/9/port/systab.h /n/bootesdump/1991/1105/sys/src/9/port/systab.h
5,11c

Syscall sysr1;
Syscall syserrstr;
Syscall sysbind;
Syscall syschdir;
Syscall sysclose;
Syscall sysdup;
Syscall sysalarm;
Syscall sysexec;
Syscall sysexits;
Syscall sysfork;
Syscall sysforkpgrp;
Syscall sysfstat;
Syscall syssegbrk;
Syscall sysmount;
Syscall sysopen;
Syscall sysread;
Syscall sysseek;
Syscall syssleep;
Syscall sysstat;
Syscall syswait;
Syscall syswrite;
Syscall syspipe;
Syscall syscreate;
Syscall sysrfork;
Syscall sysbrk_;
Syscall sysremove;
Syscall syswstat;
Syscall sysfwstat;
Syscall sysnotify;
Syscall sysnoted;
Syscall syssegattach;
Syscall syssegdetach;
Syscall syssegfree;
Syscall syssegflush;
Syscall sysrendezvous;
Syscall sysunmount;
.
## diffname port/systab.h 1992/0309
## diff -e /n/bootesdump/1991/1105/sys/src/9/port/systab.h /n/bootesdump/1992/0309/sys/src/9/port/systab.h
118a
	[WAIT]		"Wait",
.
102c
	[__WAIT__]	"__wait_",
.
79a
	[WAIT]		syswait,
.
63c
	[__WAIT__]	sys__wait__,
.
41a
Syscall syswait;
.
25c
Syscall sys__wait__;
.
## diffname port/systab.h 1992/0428
## diff -e /n/bootesdump/1992/0309/sys/src/9/port/systab.h /n/bootesdump/1992/0428/sys/src/9/port/systab.h
108c
	[__RFORK__]	"__rfork_",
.
104c
	[RFORK]		"Rfork",
.
68c
	[__RFORK__]	sys__rfork__,
.
64c
	[RFORK]		sysrfork,
.
29c
Syscall sys__rfork__;
.
25c
Syscall sysrfork;
.
## diffname port/systab.h 1992/0430
## diff -e /n/bootesdump/1992/0428/sys/src/9/port/systab.h /n/bootesdump/1992/0430/sys/src/9/port/systab.h
94c
	[__FORK__]	"__fork_",
.
54c
	[__FORK__]	sys__fork__,
.
15c
Syscall sys__fork__;
.
## diffname port/systab.h 1992/0603
## diff -e /n/bootesdump/1992/0430/sys/src/9/port/systab.h /n/bootesdump/1992/0603/sys/src/9/port/systab.h
95c
	[__FORKPGRP__]	"__forkpgrp_",
.
55c
	[__FORKPGRP__]	sys__forkpgrp__,
.
16c
Syscall sys__forkpgrp__;
.
## diffname port/systab.h 1992/0622
## diff -e /n/bootesdump/1992/0603/sys/src/9/port/systab.h /n/bootesdump/1992/0622/sys/src/9/port/systab.h
68c
	[__RFORK__]	sysdeath,
.
54,55c
	[__FORK__]	sysdeath,
	[__FORKPGRP__]	sysdeath,
.
29c
Syscall sysdeath;
.
15,16c
Syscall sysdeath;
Syscall sysdeath;
.
## diffname port/systab.h 1992/0720
## diff -e /n/bootesdump/1992/0622/sys/src/9/port/systab.h /n/bootesdump/1992/0720/sys/src/9/port/systab.h
108c
	[_X3]		"_x3",
.
94,95c
	[_X1]		"_x1",
	[_X2]		"_x2",
.
68c
	[_X3]		sysdeath,
.
54,55c
	[_X1]		sysdeath,
	[_X2]		sysdeath,
.
42a
Syscall	sysdeath;
.
29c
Syscall sys_x3;
.
15,16c
Syscall sys_x1;
Syscall sys_x2;
.
## diffname port/systab.h 1993/0209
## diff -e /n/bootesdump/1992/0720/sys/src/9/port/systab.h /n/bootesdump/1993/0209/sys/src/9/port/systab.h
122a
	[FSESSION]	"Fsession",
.
82a
	[FSESSION]	sysfsession,
.
42a
Syscall sysfsession;
.
## diffname port/systab.h 1993/0210
## diff -e /n/bootesdump/1993/0209/sys/src/9/port/systab.h /n/bootesdump/1993/0210/sys/src/9/port/systab.h
125d
97c
	[FSESSION]	"Fsession",
.
84d
56c
	[FSESSION]	sysfsession,
.
43d
15c
Syscall sysfsession;
.
## diffname port/systab.h 1993/0330
## diff -e /n/bootesdump/1993/0210/sys/src/9/port/systab.h /n/bootesdump/1993/0330/sys/src/9/port/systab.h
96c
	[FAUTH]		"Fauth",
.
56c
	[FAUTH]		sysfauth,
.
16c
Syscall sysfauth;
.
## diffname port/systab.h 1993/1004
## diff -e /n/bootesdump/1993/0330/sys/src/9/port/systab.h /n/fornaxdump/1993/1004/sys/src/brazil/port/systab.h
109c
	[PATH]		"Path",
.
69c
	[PATH]		syspath,
.
29c
Syscall syspath;
.
## diffname port/systab.h 1993/1201
## diff -e /n/fornaxdump/1993/1004/sys/src/brazil/port/systab.h /n/fornaxdump/1993/1201/sys/src/brazil/port/systab.h
122a

/* make sure port/portdat.h has NSYSCALL defined correctly!!! */
.
82a

/* make sure port/portdat.h has NSYSCALL defined correctly!!! */
.
42a
Syscall ;
Syscall /* make sure port/portdat.h has nsyscall defined correctly!!! */;
.
## diffname port/systab.h 1994/0322
## diff -e /n/fornaxdump/1993/1201/sys/src/brazil/port/systab.h /n/fornaxdump/1994/0322/sys/src/brazil/port/systab.h
128d
113c
	[FD2PATH]	"Fd2path",
.
86d
71c
	[FD2PATH]	sysfd2path,
.
44d
29c
Syscall sysfd2path;
.
## diffname port/systab.h 1994/0402
## diff -e /n/fornaxdump/1994/0322/sys/src/brazil/port/systab.h /n/fornaxdump/1994/0402/sys/src/brazil/port/systab.h
124a
	[WRITE9P]	"Write9p",

.
84a

.
83a
	[WRITE9P]	syswrite9p,
.
43a
Syscall ;
.
42a
Syscall syswrite9p;
.
## diffname port/systab.h 1994/0405
## diff -e /n/fornaxdump/1994/0402/sys/src/brazil/port/systab.h /n/fornaxdump/1994/0405/sys/src/brazil/port/systab.h
130c
	[READ9P]	"Read9p",
.
88d
86a
	[READ9P]	sysread9p,
.
45d
43a
Syscall sysread9p;
.
## diffname port/systab.h 1994/0406
## diff -e /n/fornaxdump/1994/0405/sys/src/brazil/port/systab.h /n/fornaxdump/1994/0406/sys/src/brazil/port/systab.h
131d
88d
45d
## diffname port/systab.h 1994/0407
## diff -e /n/fornaxdump/1994/0406/sys/src/brazil/port/systab.h /n/fornaxdump/1994/0407/sys/src/brazil/port/systab.h
129a

int nsyscall = (sizeof systab/sizeof systab[0]);
.
## diffname port/systab.h 1998/0319
## diff -e /n/fornaxdump/1994/0407/sys/src/brazil/port/systab.h /n/emeliedump/1998/0319/sys/src/brazil/port/systab.h
106a
	[VSEEK]		"Vseek",
.
64a
	[VSEEK]		sysvseek,
.
45d
22a
Syscall sysvseek;
.
## diffname port/systab.h 1998/0916
## diff -e /n/emeliedump/1998/0319/sys/src/brazil/port/systab.h /n/emeliedump/1998/0916/sys/src/brazil/port/systab.h
130a
	[SEEK]		"Seek",
.
107,108c
	[OSEEK]		"Oseek",
.
87a
	[SEEK]		sysseek,
.
64,65c
	[OSEEK]		sysoseek,
.
45a
Syscall sysseek;
Syscall	sysdeath;
.
22,23c
Syscall sysoseek;
.
## diffname port/systab.h 1999/0812
## diff -e /n/emeliedump/1998/0916/sys/src/brazil/port/systab.h /n/emeliedump/1999/0812/sys/src/brazil/port/systab.h
131a
	[TUNNEL]	"Tunnel",
	[EXPORTFS]	"Exportfs",
.
88a
	[TUNNEL]	systunnel,
	[EXPORTFS]	sysexportfs,
.
6,45c
Syscall sysr1;Syscall ;
Syscall syserrstr;Syscall ;
Syscall sysbind;Syscall ;
Syscall syschdir;Syscall ;
Syscall sysclose;Syscall ;
Syscall sysdup;Syscall ;
Syscall sysalarm;Syscall ;
Syscall sysexec;Syscall ;
Syscall sysexits;Syscall ;
Syscall sysfsession;Syscall ;
Syscall sysfauth;Syscall ;
Syscall sysfstat;Syscall ;
Syscall syssegbrk;Syscall ;
Syscall sysmount;Syscall ;
Syscall sysopen;Syscall ;
Syscall sysread;Syscall ;
Syscall sysoseek;Syscall ;
Syscall syssleep;Syscall ;
Syscall sysstat;Syscall ;
Syscall sysrfork;Syscall ;
Syscall syswrite;Syscall ;
Syscall syspipe;Syscall ;
Syscall syscreate;Syscall ;
Syscall sysfd2path;Syscall ;
Syscall sysbrk_;Syscall ;
Syscall sysremove;Syscall ;
Syscall syswstat;Syscall ;
Syscall sysfwstat;Syscall ;
Syscall sysnotify;Syscall ;
Syscall sysnoted;Syscall ;
Syscall syssegattach;Syscall ;
Syscall syssegdetach;Syscall ;
Syscall syssegfree;Syscall ;
Syscall syssegflush;Syscall ;
Syscall sysrendezvous;Syscall ;
Syscall sysunmount;Syscall ;
Syscall syswait;Syscall ;
Syscall syswrite9p;Syscall ;
Syscall sysread9p;Syscall ;
Syscall sysseek;Syscall ;
Syscall systunnel;Syscall ;
Syscall sysexportfs;Syscall ;
.
## diffname port/systab.h 1999/0813
## diff -e /n/emeliedump/1999/0812/sys/src/brazil/port/systab.h /n/emeliedump/1999/0813/sys/src/brazil/port/systab.h
6,47c
Syscall sysr1;
Syscall syserrstr;
Syscall sysbind;
Syscall syschdir;
Syscall sysclose;
Syscall sysdup;
Syscall sysalarm;
Syscall sysexec;
Syscall sysexits;
Syscall sysfsession;
Syscall sysfauth;
Syscall sysfstat;
Syscall syssegbrk;
Syscall sysmount;
Syscall sysopen;
Syscall sysread;
Syscall sysoseek;
Syscall syssleep;
Syscall sysstat;
Syscall sysrfork;
Syscall syswrite;
Syscall syspipe;
Syscall syscreate;
Syscall sysfd2path;
Syscall sysbrk_;
Syscall sysremove;
Syscall syswstat;
Syscall sysfwstat;
Syscall sysnotify;
Syscall sysnoted;
Syscall syssegattach;
Syscall syssegdetach;
Syscall syssegfree;
Syscall syssegflush;
Syscall sysrendezvous;
Syscall sysunmount;
Syscall syswait;
Syscall syswrite9p;
Syscall sysread9p;
Syscall sysseek;
Syscall systunnel;
Syscall sysexportfs;
.
## diffname port/systab.h 1999/1109
## diff -e /n/emeliedump/1999/0813/sys/src/brazil/port/systab.h /n/emeliedump/1999/1109/sys/src/9/port/systab.h
136,137d
91,92d
46,47d
## diffname port/systab.h 2001/0223
## diff -e /n/emeliedump/1999/1109/sys/src/9/port/systab.h /n/emeliedump/2001/0223/sys/src/9/port/systab.h
131a
	[PREAD]		"Pread",
	[PWRITE]	"Pwrite",
.
88a
	[PREAD]		syspread,
	[PWRITE]	syspwrite,
.
45a
Syscall syspread;
Syscall syspwrite;
.
## diffname port/systab.h 2001/0527
## diff -e /n/emeliedump/2001/0223/sys/src/9/port/systab.h /n/emeliedump/2001/0527/sys/src/9/port/systab.h
135a
	[FVERSION]	"Fversion",
	[ERRSTR]	"Errstr",
	[STAT]		"Stat",
	[FSTAT]		"Fstat",
	[WSTAT]		"Wstat",
	[FWSTAT]	"Fwstat",
.
133,134d
122,123c
	[_WSTAT]	"_wstat",
	[_FWSTAT]	"_fwstat",
.
116c
	[_WRITE]	"_write",
.
114c
	[_STAT]		"_stat",
.
111c
	[_READ]		"_read",
.
107c
	[_FSTAT]	"_fstat",
.
97c
	[_ERRSTR]	"_errstr",
.
90a
	[FVERSION]	sysfversion,
	[ERRSTR]	syserrstr,
	[STAT]		sysstat,
	[FSTAT]		sysfstat,
	[WSTAT]		syswstat,
	[FWSTAT]	sysfwstat,
.
88,89d
77,78c
	[_WSTAT]	sys_wstat,
	[_FWSTAT]	sys_fwstat,
.
71c
	[_WRITE]	sys_write,
.
69c
	[_STAT]		sys_stat,
.
66c
	[_READ]		sys_read,
.
62c
	[_FSTAT]	sys_fstat,
.
52c
	[_ERRSTR]	sys_errstr,
.
45a
Syscall sysfversion;
Syscall syserrstr;
Syscall sysstat;
Syscall sysfstat;
Syscall syswstat;
Syscall sysfwstat;
.
43,44d
32,33c
Syscall sys_wstat;
Syscall sys_fwstat;
.
26c
Syscall sys_write;
.
24c
Syscall sys_stat;
.
21c
Syscall sys_read;
.
17c
Syscall sys_fstat;
.
7c
Syscall sys_errstr;
.
1d
## diffname port/systab.h 2001/0819
## diff -e /n/emeliedump/2001/0527/sys/src/9/port/systab.h /n/emeliedump/2001/0819/sys/src/9/port/systab.h
146a
	[MOUNT]		"Mount",
	[AWAIT]		"Await",
.
139c
	[_WAIT]		"_wait",
.
116c
	[_MOUNT]	"_mount",
.
112c
	[_FSESSION]	"_fsession",
.
97a
	[MOUNT]		sysmount,
	[AWAIT]		sysawait,
.
90c
	[_WAIT]		sys_wait,
.
67c
	[_MOUNT]	sys_mount,
.
63c
	[_FSESSION]	sys_fsession,
.
48a
Syscall sysmount;
Syscall sysawait;
.
41c
Syscall sys_wait;
.
18c
Syscall sys_mount;
.
14c
Syscall sys_fsession;
.
