## diffname power/errno.h 1990/0227
## diff -e /dev/null /n/bootesdump/1990/0227/sys/src/9/mips/errno.h
0a
enum{
	Enevermind,	/* never mind */
	Enofd,		/* no free file descriptors */
	Ebadfd,		/* fd out of range or not open */
	Ebadusefd,	/* inappropriate use of fd */
	Ebadarg,	/* bad arg in system call */
	Enonexist,	/* file does not exist */
	Efilename,	/* file name syntax */
	Ebadchar,	/* bad character in file name */
	Ebadsharp,	/* unknown device in # filename */
	Ebadexec,	/* a.out header invalid */
	Eioload,	/* i/o error in demand load */
	Eperm,		/* permission denied */
	Enotdir,	/* not a directory */
	Enochild,	/* no living children */
	Enoseg,		/* no free segments */
	Ebadmount,	/* inconsistent mount */
	Enomount,	/* mount table full */
	Enomntdev,	/* no free mount devices */
	Eshutdown,	/* mounted device shut down */
	Einuse,		/* device or object already in use */
	Eio,		/* i/o error */
	Eisdir,		/* file is a directory */
	Ebaddirread,	/* directory read not quantized */
	Esegaddr,	/* illegal segment addresses or size */
	Enoenv,		/* no free environment resources */
	Eprocdied,	/* process exited */
	Enocreate,	/* mounted directory forbids creation */
	Enotunion,	/* attempt to union with non-mounted directory */
	Emount,		/* inconsistent mount */
	Enosrv,		/* no free server slots */
	Enoqueue,	/* no free stream queues */
	Ebadld,		/* illegal line discipline */
	Enostream,	/* no free stream heads */
	Etoobig,	/* read or write too large */
	Etoosmall,	/* read or write too small */
	Ehungup,	/* write to hungup stream */
	Ebadnet,	/* illegal network address */
	Enoifc,		/* no free nonet interface slots */
	Enodev,		/* no free devices */
	Ebadctl,	/* bad process control request */
	Enonote,	/* note overflow */
	Eintr,		/* interrupted */
	Egreg,		/* it's all greg's fault */
};
.
## diffname power/errno.h 1990/0312
## diff -e /n/bootesdump/1990/0227/sys/src/9/mips/errno.h /n/bootesdump/1990/0312/sys/src/9/mips/errno.h
43a
	Edestbusy,	/* datakit destination busy */
	Enetbusy,	/* datakit controller busy */
	Edestotl,	/* datakit destination out to lunch */
	Enetotl,	/* datakit controller out to lunch */
	Erejected,	/* datakit destination rejected call */
.
39c
	Enoifc,		/* no free interface slots */
.
## diffname power/errno.h 1990/0604
## diff -e /n/bootesdump/1990/0312/sys/src/9/mips/errno.h /n/bootesdump/1990/0604/sys/src/9/mips/errno.h
49a
	Eshortmsg,	/* short message */
	Ebadmsg,	/* format error or mismatch in message */
.
## diffname power/errno.h 1990/0703
## diff -e /n/bootesdump/1990/0604/sys/src/9/mips/errno.h /n/bootesdump/1990/0703/sys/src/9/mips/errno.h
51a
	Ebadcnt,	/* read count greater than requested */
.
## diffname power/errno.h 1990/0704
## diff -e /n/bootesdump/1990/0703/sys/src/9/mips/errno.h /n/bootesdump/1990/0704/sys/src/9/mips/errno.h
41c
	Ebadctl,	/* bad process or stream control request */
.
## diffname power/errno.h 1990/0705
## diff -e /n/bootesdump/1990/0704/sys/src/9/mips/errno.h /n/bootesdump/1990/0705/sys/src/9/mips/errno.h
52a
	Enoannounce,	/* listening on an unannounced network connection */
	Egreg,		/* it's all greg's fault */
.
49d
## diffname power/errno.h 1990/0722
## diff -e /n/bootesdump/1990/0705/sys/src/9/mips/errno.h /n/bootesdump/1990/0722/sys/src/9/mips/errno.h
39c
	Enoifc,		/* bad interface or no free interface slots */
.
## diffname power/errno.h 1990/0802
## diff -e /n/bootesdump/1990/0722/sys/src/9/mips/errno.h /n/bootesdump/1990/0802/sys/src/9/mips/errno.h
52a
	Enovmem,	/* virtual memory allocation failed */
.
## diffname power/errno.h 1990/0830
## diff -e /n/bootesdump/1990/0802/sys/src/9/mips/errno.h /n/bootesdump/1990/0830/sys/src/9/mips/errno.h
54c
	Egreg,		/* rob made me do it */
.
## diffname power/errno.h 1990/0907
## diff -e /n/bootesdump/1990/0830/sys/src/9/mips/errno.h /n/bootesdump/1990/0907/sys/src/9/mips/errno.h
54c
	Egreg,		/* ken hasn't implemented datakit */
.
## diffname power/errno.h 1990/1009
## diff -e /n/bootesdump/1990/0907/sys/src/9/mips/errno.h /n/bootesdump/1990/1009/sys/src/9/mips/errno.h
53a
	Enoasync,	/* out of async stream modules */
	Enopipe,	/* out of pipes */
.
## diffname power/errno.h 1990/1127
## diff -e /n/bootesdump/1990/1009/sys/src/9/mips/errno.h /n/bootesdump/1990/1127/sys/src/9/mips/errno.h
56c
	Egreg,		/* ken has implemented datakit */
.
## diffname power/errno.h 1991/0319
## diff -e /n/bootesdump/1991/0201/sys/src/9/mips/errno.h /n/bootesdump/1991/0319/sys/src/9/power/errno.h
55a
	Eisstream,	/* seek on a stream */
.
## diffname power/errno.h 1991/0424
## diff -e /n/bootesdump/1991/0319/sys/src/9/power/errno.h /n/bootesdump/1991/0424/sys/src/9/power/errno.h
55a
	Emsgsize,	/* message is too big for protocol */
	Enoport,	/* network port not available */
	Edevbusy,	/* network device is busy or allocated */
	Eaddrnotfound,	/* network address not found */
	Enetunreach,	/* network unreachable */
	Etimedout,	/* connection timed out */
	Econrefused,	/* connection refused */
	Enoproto,	/* network protocol not supported */
	Eprotonosup,	/* operation not supported by network protocol */
.
## diffname power/errno.h 1991/0724
## diff -e /n/bootesdump/1991/0424/sys/src/9/power/errno.h /n/bootesdump/1991/0724/sys/src/9/power/errno.h
2c
	Enoerror,	/* no error */
.
## diffname power/errno.h 1992/0111 # deleted
## diff -e /n/bootesdump/1991/0724/sys/src/9/power/errno.h /n/bootesdump/1992/0111/sys/src/9/power/errno.h
1,67d
