## diffname power/segment.h 1991/0705
## diff -e /dev/null /n/bootesdump/1991/0705/sys/src/9/power/segment.h
0a
/*
 * Attach segment types
 */

typedef struct Physseg Physseg;
struct Physseg
{
	ulong	attr;			/* Segment attributes */
	char	*name;			/* Attach name */
	ulong	pa;			/* Physical address */
	ulong	size;			/* Maximum segment size in pages */
	Page	*(*pgalloc)(ulong);	/* Allocation if we need it */
	void	(*pgfree)(Page*);
}physseg[] = {
	{ SG_SHARED,	"lock",		0,	1024*BY2PG,	&lkpage,	&lkpgfree },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	&snewpage, 	&putpage },
	{ SG_PHYSICAL,	"kmem",		KZERO,	SEGMAXSIZE,	0,		0 	},
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	&snewpage,	&putpage },
	{ 0,		0,		0,	0,		0,		0 	},
};
.
## diffname power/segment.h 1991/0731
## diff -e /n/bootesdump/1991/0705/sys/src/9/power/segment.h /n/bootesdump/1991/0731/sys/src/9/power/segment.h
15c
	{ SG_PHYSICAL,	"lock",		0,	1024*BY2PG,	&lkpage,	&lkpgfree },
.
## diffname power/segment.h 1991/0802
## diff -e /n/bootesdump/1991/0731/sys/src/9/power/segment.h /n/bootesdump/1991/0802/sys/src/9/power/segment.h
15,18c
	{ SG_PHYSICAL,	"lock",		0,	1024*BY2PG,	lkpage,		lkpgfree },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	snewpage, 	putpage },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	snewpage,	putpage },
.
## diffname power/segment.h 1993/0120
## diff -e /n/bootesdump/1991/0802/sys/src/9/power/segment.h /n/bootesdump/1993/0120/sys/src/9/power/segment.h
16,18c
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 	0 },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0,	0 },
	{ 0,		0,		0,	0,		0,	0 },
.
12c
	Page	*(*pgalloc)(Segment*, ulong);	/* Allocation if we need it */
.
## diffname power/segment.h 1993/0210
## diff -e /n/bootesdump/1993/0120/sys/src/9/power/segment.h /n/bootesdump/1993/0210/sys/src/9/power/segment.h
16,18c
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 0 },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0, 0 },
	{ SG_PHYSICAL,	"vme16",	VME16IO3, 	64*1024,	0, 0 },
	{ SG_PHYSICAL,	"tdsfb",	VME32TDFB, 	4*MB,		0, 0 },
	{ 0,		0,		0,	0,		0, 0 },
.
8,14d
5,6c
#define VME16IO3	0x17C10000	
#define VME32TDFB	(0x30000000+128*MB)

Physseg physseg[] =
.
## diffname power/segment.h 1993/0211
## diff -e /n/bootesdump/1993/0210/sys/src/9/power/segment.h /n/bootesdump/1993/0211/sys/src/9/power/segment.h
5c
#define VME16IO3	0x17C00000	
.
## diffname power/segment.h 1997/0327 # deleted
## diff -e /n/bootesdump/1993/0211/sys/src/9/power/segment.h /n/emeliedump/1997/0327/sys/src/brazil/power/segment.h
1,16d
