## diffname gnot/disk.c 1991/0906
## diff -e /dev/null /n/bootesdump/1991/0906/sys/src/9/gnot/disk.c
0a
#include	"u.h"
#include	"lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"errno.h"

#include	"devtab.h"

#include	"fcall.h"

Dev	devtab[]={
	{ rootreset, rootinit, rootattach, rootclone, rootwalk, rootstat, rootopen, rootcreate,
	  rootclose, rootread, rootwrite, rootremove, rootwstat, },
	{ consreset, consinit, consattach, consclone, conswalk, consstat, consopen, conscreate,
	  consclose, consread, conswrite, consremove, conswstat, },
	{ envreset, envinit, envattach, envclone, envwalk, envstat, envopen, envcreate,
	  envclose, envread, envwrite, envremove, envwstat, },
	{ pipereset, pipeinit, pipeattach, pipeclone, pipewalk, pipestat, pipeopen, pipecreate,
	  pipeclose, piperead, pipewrite, piperemove, pipewstat, },
	{ procreset, procinit, procattach, procclone, procwalk, procstat, procopen, proccreate,
	  procclose, procread, procwrite, procremove, procwstat, },
	{ srvreset, srvinit, srvattach, srvclone, srvwalk, srvstat, srvopen, srvcreate,
	  srvclose, srvread, srvwrite, srvremove, srvwstat, },
	{ mntreset, mntinit, mntattach, mntclone, mntwalk, mntstat, mntopen, mntcreate,
	  mntclose, mntread, mntwrite, mntremove, mntwstat, },
	{ inconreset, inconinit, inconattach, inconclone, inconwalk, inconstat, inconopen, inconcreate,
	  inconclose, inconread, inconwrite, inconremove, inconwstat, },
	{ dkreset, dkinit, dkattach, dkclone, dkwalk, dkstat, dkopen, dkcreate,
	  dkclose, dkread, dkwrite, dkremove, dkwstat, },
	{ dupreset, dupinit, dupattach, dupclone, dupwalk, dupstat, dupopen, dupcreate,
	  dupclose, dupread, dupwrite, dupremove, dupwstat, },
	{ bitreset, bitinit, bitattach, bitclone, bitwalk, bitstat, bitopen, bitcreate,
	  bitclose, bitread, bitwrite, bitremove, bitwstat, },
	{ portreset, portinit, portattach, portclone, portwalk, portstat, portopen, portcreate,
	  portclose, portread, portwrite, portremove, portwstat, },
	{ scsireset, scsiinit, scsiattach, scsiclone, scsiwalk, scsistat, scsiopen, scsicreate,
	  scsiclose, scsiread, scsiwrite, scsiremove, scsiwstat, },
	{ wrenreset, wreninit, wrenattach, wrenclone, wrenwalk, wrenstat, wrenopen, wrencreate,
	  wrenclose, wrenread, wrenwrite, wrenremove, wrenwstat, },
	{ duartreset, duartinit, duartattach, duartclone, duartwalk, duartstat, duartopen, duartcreate,
	  duartclose, duartread, duartwrite, duartremove, duartwstat, },
};
char devchar[]="/ce|psMikdbxSrt";
extern Qinfo	urpinfo;
extern Qinfo	asyncinfo;
extern Qinfo	fcallinfo;
void streaminit0(void){
	newqinfo(&urpinfo);
	newqinfo(&asyncinfo);
	newqinfo(&fcallinfo);
}
	/*
	 *  fake cryptfs
	 */
	long cryptfslen = 0; ulong cryptfscode[1];
	#include "cfs.h"
.
## diffname gnot/disk.c 1991/0913
## diff -e /n/bootesdump/1991/0906/sys/src/9/gnot/disk.c /n/bootesdump/1991/0913/sys/src/9/gnot/disk.c
53,55c
	long kfslen = 0; ulong kfscode[1];
.
## diffname gnot/disk.c 1991/0926
## diff -e /n/bootesdump/1991/0913/sys/src/9/gnot/disk.c /n/bootesdump/1991/0926/sys/src/9/gnot/disk.c
55a
	#include "kfs.h"
.
53,54d
44c
char devchar[]="/ce|psMikdbxSwt";
.
## diffname gnot/disk.c 1991/1011
## diff -e /n/bootesdump/1991/0926/sys/src/9/gnot/disk.c /n/bootesdump/1991/1011/sys/src/9/gnot/disk.c
54a
	void kproftimer(ulong pc){}
.
## diffname gnot/disk.c 1992/0111
## diff -e /n/bootesdump/1991/1011/sys/src/9/gnot/disk.c /n/bootesdump/1992/0111/sys/src/9/gnot/disk.c
6c
#include	"../port/error.h"
.
## diffname gnot/disk.c 1992/0321
## diff -e /n/bootesdump/1992/0111/sys/src/9/gnot/disk.c /n/bootesdump/1992/0321/sys/src/9/gnot/disk.c
2c
#include	"../port/lib.h"
.
## diffname gnot/disk.c 1993/0501 # deleted
## diff -e /n/bootesdump/1992/0321/sys/src/9/gnot/disk.c /n/fornaxdump/1993/0501/sys/src/brazil/gnot/disk.c
1,55d
