## diffname gnot/fns.h 1990/03091
## diff -e /dev/null /n/bootesdump/1990/03091/sys/src/9/68020/fns.h
0a
Alarm	*alarm(int, void (*)(Alarm*), void*);
void	alarminit(void);
Block	*allocb(ulong);
void	append(List**, List*);
void	cancel(Alarm*);
int	canlock(Lock*);
void	chaninit(void);
void	chandevreset(void);
void	chandevinit(void);
void	clock(Ureg*);
Chan	*clone(Chan*, Chan*);
void	close(Chan*);
void	closemount(Mount*);
void	closepgrp(Pgrp*);
long	clrfpintr(void);
void	compactpte(Orig*, ulong);
void	confinit(void);
Env	*copyenv(Env*, int);
int	decref(Ref*);
void	delay(int);
void	delete(List**, List*, List*);
void	delete0(List**, List*);
Chan	*devattach(int, char*);
Chan	*devclone(Chan*, Chan*);
void	devdir(Chan*, long, char*, long, long, Dir*);
long	devdirread(Chan*, char*, long, Dirtab*, int, Devgen*);
Devgen	devgen;
int	devno(int, int);
Chan*	devopen(Chan*, int, Dirtab*, int, Devgen*);
void	devstat(Chan*, char*, Dirtab*, int, Devgen*);
int	devwalk(Chan*, char*, Dirtab*, int, Devgen*);
void	dumpregs(Ureg*);
void	dumpstack(void);
int	eqchan(Chan*, Chan*, long);
void	envpgclose(Env *);
void	error(Chan*, int);
void	exit(void);
void	fault(Ureg*, FFrame*);
Chan*	fdtochan(int, int);
void	firmware(void);
void	flowctl(Queue*);
void	flushcpucache(void);
void	flushmmu(void);
void	forkmod(Seg*, Seg*, Proc*);
void	freeb(Block*);
void	freepage(Orig*);
void	freepte(Orig*);
void	freesegs(int);
void	freealarm(Alarm*);
Block	*getq(Queue *);
void	gotolabel(Label*);
void	growpte(Orig*, ulong);
void	*ialloc(ulong, int);
int	incref(Ref*);
void	insert(List**, List*, List*);
void	isdir(Chan*);
void	kbdchar(int);
void	lock(Lock*);
void	lockinit(void);
Orig	*lookorig(ulong, ulong, int, Chan*);
void	machinit(void);
void	mapstack(Proc*);
void	mmuinit(void);
int	mount(Chan*, Chan*, int);
Chan	*namec(char*, int, int, ulong);
void	nexterror(void);
Alarm	*newalarm(void);
Chan	*newchan(void);
PTE	*newmod(void);
Mount	*newmount(void);
Orig	*neworig(ulong, ulong, int, Chan*);
Page	*newpage(int, Orig*, ulong);
Pgrp	*newpgrp(void);
Proc	*newproc(void);
char	*nextelem(char*, char*);
void	nullput(Queue*, Block*);
int	openmode(ulong);
void	pageinit(void);
void	panic(char*, ...);
void	pexit(char*, int);
void	pgrpcpy(Pgrp*, Pgrp*);
void	pgrpinit(void);
int	postnote(Proc*, int, char*, int);
int	pprint(char*, ...);
void	printinit(void);
void	printslave(void);
void	procinit0(void);
Proc	*proctab(int);
void	putkmmu(ulong, ulong);
void	putmmu(ulong, ulong);
int	putq(Queue*, Block*);
void	putstr(char*);
void	putstrn(char*, long);
ulong	pwait(Waitmsg*);
int	readnum(ulong, char*, ulong, ulong, int);
void	ready(Proc*);
void	rooterrstr(Error*, char*);
void	qlock(QLock*);
void	qunlock(QLock*);
void	restartprint(Alarm*);
void	restfpregs(FPsave*);
Proc	*runproc(void);
void	savefpregs(FPsave*);
void	sched(void);
void	schedinit(void);
void	screeninit(void);
void	screenputc(int);
long	seconds(void);
Seg	*seg(Proc*, ulong);
int	segaddr(Seg*, ulong, ulong);
int	setlabel(Label*);
char*	skipslash(char*);
void	sleep(Rendez*, int(*)(void*), void*);
int	splhi(void);
int	spllo(void);
void	splx(int);
Devgen	streamgen;
void	streamclose(Chan*);
void	streaminit(void);
long	streamread(Chan*, void*, long);
long	streamwrite(Chan*, void*, long);
Stream*	streamnew(Chan*, Qinfo*);
void	streamopen(Chan*, Qinfo*);
int	streamparse(char*, Block*);
long	syscall(Ureg*);
int	tas(char*);
void	touser(void);
void	tsleep(Rendez*, int (*)(void*), void*, int);
void	twakeme(Alarm*);
void	unlock(Lock*);
void	usepage(Page*, int);
void	userinit(void);
void	validaddr(ulong, ulong, int);
void*	vmemchr(void*, int, int);
void	wakeme(Alarm*);
void	wakeup(Rendez*);

#define	waserror()	(u->nerrlab++, setlabel(&u->errlab[u->nerrlab-1]))
#define	poperror()	u->nerrlab--

#define	evenaddr(x)	/* 68020 doesn't care */
.
## diffname gnot/fns.h 1990/0312
## diff -e /n/bootesdump/1990/03091/sys/src/9/68020/fns.h /n/bootesdump/1990/0312/sys/src/9/68020/fns.h
124a
long	stringread(Chan*, void*, long, char*);
.
121c
long	streamwrite(Chan*, void*, long, int);
.
88a
Queue*	pushq(Stream*, Qinfo*);
void	putbq(Blist*, Block*);
.
57a
void	kproc(char*, void(*)(void*), void*);
.
50c
Block	*getb(Blist*);
int	getfields(char*, char**, int, char);
Block	*getq(Queue*);
.
6a
int	canqlock(QLock*);
.
## diffname gnot/fns.h 1990/0321
## diff -e /n/bootesdump/1990/0312/sys/src/9/68020/fns.h /n/bootesdump/1990/0321/sys/src/9/68020/fns.h
78a
void	newqinfo(Qinfo*);
.
60a
void	kbdrepeat(int);
void	kbdclock(void);
.
10a
void	checksched(void);
.
## diffname gnot/fns.h 1990/0329
## diff -e /n/bootesdump/1990/0321/sys/src/9/68020/fns.h /n/bootesdump/1990/0329/sys/src/9/68020/fns.h
71a
void	mousebuttons(int);
.
## diffname gnot/fns.h 1990/0330
## diff -e /n/bootesdump/1990/0329/sys/src/9/68020/fns.h /n/bootesdump/1990/0330/sys/src/9/68020/fns.h
64a
void	kproftimer(ulong);
.
33a
void	duartstarttimer(void);
void	duartstoptimer(void);
.
## diffname gnot/fns.h 1990/0504
## diff -e /n/bootesdump/1990/0330/sys/src/9/68020/fns.h /n/bootesdump/1990/0504/sys/src/9/68020/fns.h
75a
void	mouseclock(void);
.
## diffname gnot/fns.h 1990/05313
## diff -e /n/bootesdump/1990/0504/sys/src/9/68020/fns.h /n/bootesdump/1990/05313/sys/src/9/68020/fns.h
111a
int	return0(void*);
.
## diffname gnot/fns.h 1990/06021
## diff -e /n/bootesdump/1990/05313/sys/src/9/68020/fns.h /n/bootesdump/1990/06021/sys/src/9/68020/fns.h
67a
void	kunmap(KMap*);
.
65a
void	kmapinit(void);
KMap	*kmap(Page*);
.
## diffname gnot/fns.h 1990/0620
## diff -e /n/bootesdump/1990/06021/sys/src/9/68020/fns.h /n/bootesdump/1990/0620/sys/src/9/68020/fns.h
137a
int	streamenter(Stream*);
void	streamexit(Stream*, int);
.
## diffname gnot/fns.h 1990/0629
## diff -e /n/bootesdump/1990/0620/sys/src/9/68020/fns.h /n/bootesdump/1990/0629/sys/src/9/68020/fns.h
116a
void	rs232ichar(int);
.
56a
int	getrs232o(void);
.
33a
void	duartstartrs232o(void);
.
## diffname gnot/fns.h 1990/0703
## diff -e /n/bootesdump/1990/0629/sys/src/9/68020/fns.h /n/bootesdump/1990/0703/sys/src/9/68020/fns.h
93a
void	notify(Ureg*);
.
## diffname gnot/fns.h 1990/0707
## diff -e /n/bootesdump/1990/0703/sys/src/9/68020/fns.h /n/bootesdump/1990/0707/sys/src/9/68020/fns.h
69a
int	kprint(char*, ...);
.
## diffname gnot/fns.h 1990/0717
## diff -e /n/bootesdump/1990/0707/sys/src/9/68020/fns.h /n/bootesdump/1990/0717/sys/src/9/68020/fns.h
157a
void	urpreset(void);
.
## diffname gnot/fns.h 1990/0801
## diff -e /n/bootesdump/1990/0717/sys/src/9/68020/fns.h /n/bootesdump/1990/0801/sys/src/9/68020/fns.h
150a
void	streamstat(Chan*, char*, char*);
.
## diffname gnot/fns.h 1990/0802
## diff -e /n/bootesdump/1990/0801/sys/src/9/68020/fns.h /n/bootesdump/1990/0802/sys/src/9/68020/fns.h
18c
int	compactpte(Orig*, ulong);
.
## diffname gnot/fns.h 1990/0808
## diff -e /n/bootesdump/1990/0802/sys/src/9/68020/fns.h /n/bootesdump/1990/0808/sys/src/9/68020/fns.h
33a
void	duartbaud(int);
.
## diffname gnot/fns.h 1990/08101
## diff -e /n/bootesdump/1990/0808/sys/src/9/68020/fns.h /n/bootesdump/1990/08101/sys/src/9/68020/fns.h
51a
void	freenextmod(PTE*);
.
## diffname gnot/fns.h 1990/08141
## diff -e /n/bootesdump/1990/08101/sys/src/9/68020/fns.h /n/bootesdump/1990/08141/sys/src/9/68020/fns.h
44a
void	fdclose(int);
.
## diffname gnot/fns.h 1990/08163
## diff -e /n/bootesdump/1990/08141/sys/src/9/68020/fns.h /n/bootesdump/1990/08163/sys/src/9/68020/fns.h
51a
int	fpcr(int);
void	fpsave(FPsave*);
void	fpregsave(char*);
void	fprestore(FPsave*);
void	fpregrestore(char*);
.
## diffname gnot/fns.h 1990/0830
## diff -e /n/bootesdump/1990/08163/sys/src/9/68020/fns.h /n/bootesdump/1990/0830/sys/src/9/68020/fns.h
34a
void	duartbreak(int);
void	duartdtr(int);
int	duartinputport(void);
.
## diffname gnot/fns.h 1990/0905
## diff -e /n/bootesdump/1990/0830/sys/src/9/68020/fns.h /n/bootesdump/1990/0905/sys/src/9/68020/fns.h
108a
Block*	padb(Block*, int);
.
## diffname gnot/fns.h 1990/0911
## diff -e /n/bootesdump/1990/0905/sys/src/9/68020/fns.h /n/bootesdump/1990/0911/sys/src/9/68020/fns.h
171d
## diffname gnot/fns.h 1990/0921
## diff -e /n/bootesdump/1990/0911/sys/src/9/68020/fns.h /n/bootesdump/1990/0921/sys/src/9/68020/fns.h
53a
void	flushmmucache(void);
.
## diffname gnot/fns.h 1990/0925
## diff -e /n/bootesdump/1990/0921/sys/src/9/68020/fns.h /n/bootesdump/1990/0925/sys/src/9/68020/fns.h
54d
11a
void	clearmmucache(void);
.
## diffname gnot/fns.h 1990/1004
## diff -e /n/bootesdump/1990/0925/sys/src/9/68020/fns.h /n/bootesdump/1990/1004/sys/src/9/68020/fns.h
153a
void	spldone(void);
.
139c
void	restore(void);
.
84d
## diffname gnot/fns.h 1990/1009
## diff -e /n/bootesdump/1990/1004/sys/src/9/68020/fns.h /n/bootesdump/1990/1009/sys/src/9/68020/fns.h
161c
Stream*	streamnew(ushort, ushort, ushort, Qinfo*, int);
.
155a
void	streamclose1(Stream*);
.
## diffname gnot/fns.h 1990/1024
## diff -e /n/bootesdump/1990/1009/sys/src/9/68020/fns.h /n/bootesdump/1990/1024/sys/src/9/68020/fns.h
158c
int	streamexit(Stream*, int);
.
## diffname gnot/fns.h 1990/1104
## diff -e /n/bootesdump/1990/1024/sys/src/9/68020/fns.h /n/bootesdump/1990/1104/sys/src/9/68020/fns.h
146a
void	serviceinit(void);
void	service(char*, Chan*, void (*)(Chan*, char*, long));
.
83c
Proc	*kproc(char*, void(*)(void*), void*);
.
50a
void	filsys(Chan*, char*, long);
.
## diffname gnot/fns.h 1990/1106
## diff -e /n/bootesdump/1990/1104/sys/src/9/68020/fns.h /n/bootesdump/1990/1106/sys/src/9/68020/fns.h
181a
Chan	*walk(Chan*, char*, int);
.
179c
void	*vmemchr(void*, int, int);
.
174a
long	unionread(Chan*, void*, long);
.
165c
Stream	*streamnew(ushort, ushort, ushort, Qinfo*, int);
.
151c
char	*skipslash(char*);
.
149c
void	service(char*, Chan*, Chan*, void (*)(Chan*, char*, long));
.
122c
Queue	*pushq(Stream*, Qinfo*);
.
115a
void	pgrpnote(Pgrp*, char*, long, int);
Pgrp	*pgrptab(int);
.
110c
Block	*padb(Block*, int);
.
84c
void	*kproc(char*, void(*)(void*), void*);
.
50c
Chan	*fdtochan(int, int);
.
32c
Chan	*devopen(Chan*, int, Dirtab*, int, Devgen*);
.
21a
Chan	*createdir(Chan*);
.
## diffname gnot/fns.h 1990/11062
## diff -e /n/bootesdump/1990/1106/sys/src/9/68020/fns.h /n/bootesdump/1990/11062/sys/src/9/68020/fns.h
35a
Chan	*domount(Chan*);
.
## diffname gnot/fns.h 1990/1110
## diff -e /n/bootesdump/1990/11062/sys/src/9/68020/fns.h /n/bootesdump/1990/1110/sys/src/9/68020/fns.h
53a
void	filsysinit(void);
.
## diffname gnot/fns.h 1990/11211
## diff -e /n/bootesdump/1990/1110/sys/src/9/68020/fns.h /n/bootesdump/1990/11211/sys/src/9/68020/fns.h
163,164c
int	streamclose(Chan*);
int	streamclose1(Stream*);
.
138d
48c
void	error(int);
void	errors(char*);
.
46a
int	eqqid(Qid, Qid);
.
29c
void	devdir(Chan*, Qid, char*, long, long, Dir*);
.
## diffname gnot/fns.h 1990/1211
## diff -e /n/bootesdump/1990/11211/sys/src/9/68020/fns.h /n/bootesdump/1990/1211/sys/src/9/68020/fns.h
183a
void	unusepage(Page*, int);
.
156a
void	setup(Proc*);
.
145c
void	restore(Proc*, uchar*);
void	save(uchar*, int);
.
140a
Proc	*runproc(void);
.
89c
void	kproc(char*, void(*)(void*), void*);
.
81a
void	invalidateu(void);
.
11c
void	checkalarms(void);
.
## diffname gnot/fns.h 1990/1212
## diff -e /n/bootesdump/1990/1211/sys/src/9/68020/fns.h /n/bootesdump/1990/1212/sys/src/9/68020/fns.h
160d
147,148d
128a
void	procrestore(Proc*, uchar*);
void	procsave(uchar*, int);
void	procsetup(Proc*);
.
105c
PTE	*newmod(Orig *o);
.
69c
void	freepage(Orig*, int);
.
67a
int	freebroken(void);
.
52c
int	fault(ulong, int);
void	fault68020(Ureg*, FFrame*);
.
## diffname gnot/fns.h 1990/1214
## diff -e /n/bootesdump/1990/1212/sys/src/9/68020/fns.h /n/bootesdump/1990/1214/sys/src/9/68020/fns.h
201a

#define USED(x) if(x)
.
## diffname gnot/fns.h 1990/1226
## diff -e /n/bootesdump/1990/1214/sys/src/9/68020/fns.h /n/bootesdump/1990/1226/sys/src/9/68020/fns.h
50a
void	execpc(ulong);
.
## diffname gnot/fns.h 1990/1227
## diff -e /n/bootesdump/1990/1226/sys/src/9/68020/fns.h /n/bootesdump/1990/1227/sys/src/9/68020/fns.h
3a
int	anyready(void);
.
## diffname gnot/fns.h 1991/0109
## diff -e /n/bootesdump/1990/1227/sys/src/9/68020/fns.h /n/bootesdump/1991/0109/sys/src/9/68020/fns.h
205c
#define USED(x)	if(x)
#define SET(x)	x = 0
.
## diffname gnot/fns.h 1991/0115
## diff -e /n/bootesdump/1991/0109/sys/src/9/68020/fns.h /n/bootesdump/1991/0115/sys/src/9/68020/fns.h
206a
#define	flushvirt()

/*
 *  for SCSI
 */
#define P_qlock(sel)	(sel >= 0 ? (qlock(&portpage), \
				PORTSELECT = portpage.select = sel) : -1)

#define P_qunlock(sel)	(sel >= 0 ? (qunlock(&portpage),0) : -1)

#define P_oper(sel, inst)	(P_qlock(sel), inst, P_qunlock(sel))

#define P_read(sel, addr, val, type)	P_oper(sel, val = *(type *)(PORT+addr))

#define P_write(sel, addr, val, type)	P_oper(sel, *(type *)(PORT+addr) = val)

.
176a
void	streaminit0(void);
.
166a
int	spl1(void);
.
158a
int	scsicap(int, uchar *);
void	scsicmd(Scsi *, int, int, uchar *, long);
void	scsictrlintr(void);
void	scsidmaintr(void);
int	scsiexec(Scsi *, int);
void	scsiinit(void);
void	scsirun(void);
int	scsiready(int);
uchar	*scsirecv(uchar *);
void	scsireset(void);
int	scsisense(int, uchar *);
uchar	*scsixmit(uchar *);
.
127a
int	portprobe(char*, int, int, int, long);
.
83a
void	incontoggle(void);
.
45a
void	dumpqueues(void);
.
4a
void	addportintr(int (*)(void));
.
## diffname gnot/fns.h 1991/0312
## diff -e /n/bootesdump/1991/0201/sys/src/9/68020/fns.h /n/bootesdump/1991/0312/sys/src/9/gnot/fns.h
225a
#define	flushapage(x)
.
## diffname gnot/fns.h 1991/0314
## diff -e /n/bootesdump/1991/0312/sys/src/9/gnot/fns.h /n/bootesdump/1991/0314/sys/src/9/gnot/fns.h
241a

#define flushpage(x) if(x)
.
## diffname gnot/fns.h 1991/0325
## diff -e /n/bootesdump/1991/0314/sys/src/9/gnot/fns.h /n/bootesdump/1991/0325/sys/src/9/gnot/fns.h
38d
## diffname gnot/fns.h 1991/0411
## diff -e /n/bootesdump/1991/0325/sys/src/9/gnot/fns.h /n/bootesdump/1991/0411/sys/src/9/gnot/fns.h
200c
long	stringread(Chan*, void*, long, char*, ulong);
.
## diffname gnot/fns.h 1991/0414
## diff -e /n/bootesdump/1991/0411/sys/src/9/gnot/fns.h /n/bootesdump/1991/0414/sys/src/9/gnot/fns.h
72a
void	freechan(Chan*);
.
## diffname gnot/fns.h 1991/0419
## diff -e /n/bootesdump/1991/0414/sys/src/9/gnot/fns.h /n/bootesdump/1991/0419/sys/src/9/gnot/fns.h
30a
Chan	*devclwalk(Chan*, char*);
.
## diffname gnot/fns.h 1991/0423
## diff -e /n/bootesdump/1991/0419/sys/src/9/gnot/fns.h /n/bootesdump/1991/0423/sys/src/9/gnot/fns.h
217d
184a
int	splduart(void);
.
165c
Scsi	*scsicmd(int, int, long);
.
24d
## diffname gnot/fns.h 1991/0428
## diff -e /n/bootesdump/1991/0423/sys/src/9/gnot/fns.h /n/bootesdump/1991/0428/sys/src/9/gnot/fns.h
219,243d
206,217d
189,203c
int	splduart(void);
.
184,187d
174,182c
uchar*	scsixmit(uchar *);
.
172a
void	scsirun(void);
.
171c
uchar*	scsirecv(uchar *);
.
169d
164c
Scsi*	scsicmd(int, int, long);
.
158,160c
void	rs232ichar(int);
.
148,155d
144,145d
140,142d
135,136d
132,133d
108,130d
105d
99,103d
97d
95d
93a
void	kbdrepeat(int);
KMap*	kmap(Page*);
.
92d
87,90d
83,85d
70,81c
void	fpsave(FPsave*);
.
67c
void	fpregrestore(char*);
.
64,65c
#define	flushpage(x) if(x)
#define	flushvirt()
.
57,62c
#define	flushapage(x)
.
45,55c
#define	evenaddr(x)	/* 68020 doesn't care */
.
15,37d
6,13d
1,4c
#include "../port/portfns.h"

#define	P_oper(sel, inst)	(P_qlock(sel), inst, P_qunlock(sel))
#define	P_qlock(sel)	(sel >= 0 ? (qlock(&portpage), PORTSELECT = portpage.select = sel) : -1)
#define	P_qunlock(sel)	(sel >= 0 ? (qunlock(&portpage),0) : -1)
#define	P_read(sel, addr, val, type)	P_oper(sel, val = *(type *)(PORT+addr))
#define	P_write(sel, addr, val, type)	P_oper(sel, *(type *)(PORT+addr) = val)

.
## diffname gnot/fns.h 1991/0605
## diff -e /n/bootesdump/1991/0428/sys/src/9/gnot/fns.h /n/bootesdump/1991/0605/sys/src/9/gnot/fns.h
53a
void	screenputs(char*, int);
.
51c
void	rs232puts(IOQ*, char*, int);
void	rs232rintr(char);
void	rs232xintr(void);
.
45a
int	putc(IOQ*, int);
void	puts(IOQ*, void*, int);
.
40a
int	mouseputc(IOQ*, int);
.
31c
void	initq(IOQ*);
int	kbdputc(IOQ*, int);
.
29c
int	getc(IOQ*);
int	gets(IOQ*, void*, int);
.
15c
void	duartrs232start(char);
void	duartrs232stop(void);
void	duartrs232xmit(char);
.
9a
int	cangetc(void*);
int	canputc(void*);
.
## diffname gnot/fns.h 1991/0606
## diff -e /n/bootesdump/1991/0605/sys/src/9/gnot/fns.h /n/bootesdump/1991/0606/sys/src/9/gnot/fns.h
83a

/*
 *  for queues (to go into portfns.h)
 */
int	cangetc(void*);
int	canputc(void*);
int	getc(IOQ*);
int	gets(IOQ*, void*, int);
void	initq(IOQ*);
int	putc(IOQ*, int);
void	puts(IOQ*, void*, int);

/*
 *  for devcons (to go into portfns.h)
 */
void	kbdclock(void);
void	kbdrepeat(int);
int	kbdputc(IOQ*, int);
int	kprint(char*, ...);
int	mouseputc(IOQ*, int);
void	printinit(void);
void	putstr(char*);
void	putstrn(char*, long);
.
60,62d
56,57d
53,54d
49d
47d
42d
36,39d
33,34d
13,19c
void	duartinit(void);
.
10,11d
## diffname gnot/fns.h 1991/0607
## diff -e /n/bootesdump/1991/0606/sys/src/9/gnot/fns.h /n/bootesdump/1991/0607/sys/src/9/gnot/fns.h
60,82d
## diffname gnot/fns.h 1991/0705
## diff -e /n/bootesdump/1991/0607/sys/src/9/gnot/fns.h /n/bootesdump/1991/0705/sys/src/9/gnot/fns.h
24a
#define icflush(a, b)
.
## diffname gnot/fns.h 1991/0927
## diff -e /n/bootesdump/1991/0705/sys/src/9/gnot/fns.h /n/bootesdump/1991/0927/sys/src/9/gnot/fns.h
53d
51d
47,49d
44d
42a
Scsibuf	*scsialloc(ulong);
int	scsibread(int, Scsibuf*, long, long, long);
int	scsibwrite(int, Scsibuf*, long, long, long);
Scsibuf	*scsibuf(void);
int	scsicap(int, void*);
void	scsifree(Scsibuf*);
int	scsiready(int);
int	scsisense(int, void *);
.
## diffname gnot/fns.h 1991/1003
## diff -e /n/bootesdump/1991/0927/sys/src/9/gnot/fns.h /n/bootesdump/1991/1003/sys/src/9/gnot/fns.h
10a
void	duartclock(void);
.
## diffname gnot/fns.h 1991/1007
## diff -e /n/bootesdump/1991/1003/sys/src/9/gnot/fns.h /n/bootesdump/1991/1007/sys/src/9/gnot/fns.h
20d
## diffname gnot/fns.h 1992/0101
## diff -e /n/bootesdump/1991/1007/sys/src/9/gnot/fns.h /n/bootesdump/1992/0101/sys/src/9/gnot/fns.h
62a
#define	kmapperm(x)	kmap(x)
.
## diffname gnot/fns.h 1992/0122
## diff -e /n/bootesdump/1992/0101/sys/src/9/gnot/fns.h /n/bootesdump/1992/0122/sys/src/9/gnot/fns.h
34,35c
void	procrestore(Proc*);
void	procsave(Proc*);
.
## diffname gnot/fns.h 1992/0222
## diff -e /n/bootesdump/1992/0122/sys/src/9/gnot/fns.h /n/bootesdump/1992/0222/sys/src/9/gnot/fns.h
63a
#define getcallerpc(x)	(*(ulong*)(x))
.
## diffname gnot/fns.h 1992/0318
## diff -e /n/bootesdump/1992/0222/sys/src/9/gnot/fns.h /n/bootesdump/1992/0318/sys/src/9/gnot/fns.h
61c
void	touser(void*);
.
9a
void	bootargs(ulong);
.
## diffname gnot/fns.h 1992/0602
## diff -e /n/bootesdump/1992/0318/sys/src/9/gnot/fns.h /n/bootesdump/1992/0602/sys/src/9/gnot/fns.h
39d
## diffname gnot/fns.h 1992/0610
## diff -e /n/bootesdump/1992/0602/sys/src/9/gnot/fns.h /n/bootesdump/1992/0610/sys/src/9/gnot/fns.h
17a
void	firmware(void);
.
## diffname gnot/fns.h 1992/0621
## diff -e /n/bootesdump/1992/0610/sys/src/9/gnot/fns.h /n/bootesdump/1992/0621/sys/src/9/gnot/fns.h
65a
#define KADDR(a)	((void*)((ulong)(a)|KZERO))
#define PADDR(a)	((ulong)(a)&~KZERO)
.
3,8d
## diffname gnot/fns.h 1992/0806
## diff -e /n/bootesdump/1992/0621/sys/src/9/gnot/fns.h /n/bootesdump/1992/0806/sys/src/9/gnot/fns.h
16a
ulong	fpiar(void);
.
## diffname gnot/fns.h 1992/0808
## diff -e /n/bootesdump/1992/0806/sys/src/9/gnot/fns.h /n/bootesdump/1992/0808/sys/src/9/gnot/fns.h
39,47d
## diffname gnot/fns.h 1992/0914
## diff -e /n/bootesdump/1992/0808/sys/src/9/gnot/fns.h /n/bootesdump/1992/0914/sys/src/9/gnot/fns.h
21a
ulong	getsr(void);
.
## diffname gnot/fns.h 1992/1015
## diff -e /n/bootesdump/1992/0914/sys/src/9/gnot/fns.h /n/bootesdump/1992/1015/sys/src/9/gnot/fns.h
49a
#define	screenupdate(a)
.
## diffname gnot/fns.h 1992/1030
## diff -e /n/bootesdump/1992/1015/sys/src/9/gnot/fns.h /n/bootesdump/1992/1030/sys/src/9/gnot/fns.h
50d
## diffname gnot/fns.h 1993/0116
## diff -e /n/bootesdump/1992/1030/sys/src/9/gnot/fns.h /n/bootesdump/1993/0116/sys/src/9/gnot/fns.h
28a
#define	mmunewpage(x)
.
## diffname gnot/fns.h 1993/0501 # deleted
## diff -e /n/bootesdump/1993/0116/sys/src/9/gnot/fns.h /n/fornaxdump/1993/0501/sys/src/brazil/gnot/fns.h
1,55d
