## diffname gnot/segment.h 1991/0705
## diff -e /dev/null /n/bootesdump/1991/0705/sys/src/9/gnot/segment.h
0a
/*
 * Attach segment types
 */

typedef struct Physseg Physseg;
struct Physseg
{
	ulong	attr;			/* Segment attributes */
	char	*name;			/* Attach name */
	ulong	pa;			/* Physical address */
	ulong	size;			/* Maximum segment size in pages */
	Page	*(*pgalloc)(ulong);	/* Allocation if we need it */
	void	(*pgfree)(Page*);
}physseg[] = {
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	&snewpage, 	&putpage },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	&snewpage, 	&putpage },
	{ SG_PHYSICAL,	"kmem",		KZERO,	SEGMAXSIZE,	0,		0 	},
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	&snewpage,	&putpage },
	{ 0,		0,		0,	0,		0,		0 	},
};
.
## diffname gnot/segment.h 1992/0207
## diff -e /n/bootesdump/1991/0705/sys/src/9/gnot/segment.h /n/bootesdump/1992/0207/sys/src/9/gnot/segment.h
18c
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	snewpage,	putpage },
.
15,16c
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	snewpage, 	putpage },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	snewpage, 	putpage },
.
## diffname gnot/segment.h 1993/0115
## diff -e /n/bootesdump/1992/0207/sys/src/9/gnot/segment.h /n/bootesdump/1993/0115/sys/src/9/gnot/segment.h
17d
## diffname gnot/segment.h 1993/0120
## diff -e /n/bootesdump/1993/0115/sys/src/9/gnot/segment.h /n/bootesdump/1993/0120/sys/src/9/gnot/segment.h
15,18c
	{ SG_SHARED,	"lock",		0,	SEGMAXSIZE,	0, 	0 },
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 	0 },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0,	0 },
	{ 0,		0,		0,	0,		0,	0 },
.
12c
	Page	*(*pgalloc)(Segment*, ulong);	/* Allocation if we need it */
.
## diffname gnot/segment.h 1993/0226
## diff -e /n/bootesdump/1993/0120/sys/src/9/gnot/segment.h /n/bootesdump/1993/0226/sys/src/9/gnot/segment.h
5,14c
Physseg physseg[] = {
.
## diffname gnot/segment.h 1993/0501 # deleted
## diff -e /n/bootesdump/1993/0226/sys/src/9/gnot/segment.h /n/fornaxdump/1993/0501/sys/src/brazil/gnot/segment.h
1,10d
