## diffname mpc/etherif.h 1999/0121
## diff -e /dev/null /n/emeliedump/1999/0121/sys/src/brazil/mpc/etherif.h
0a
enum {
	MaxEther	= 24,
	Ntypes		= 8,
};

typedef struct Ether Ether;
struct Ether {
	ISAConf;			/* hardware info */
	int	ctlrno;
	int	tbdf;			/* type+busno+devno+funcno */
	int	mbps;			/* Mbps */
	uchar	ea[Eaddrlen];

	void	(*attach)(Ether*);	/* filled in by reset routine */
	void	(*closed)(Ether*);
	void	(*detach)(Ether*);
	void	(*transmit)(Ether*);
	void	(*interrupt)(Ureg*, void*);
	long	(*ifstat)(Ether*, void*, long, ulong);
	void	*ctlr;

	Queue*	oq;

	Netif;
};

extern Block* etheriq(Ether*, Block*, int);
extern void addethercard(char*, int(*)(Ether*));
.
## diffname mpc/etherif.h 2000/0516
## diff -e /n/emeliedump/1999/0121/sys/src/brazil/mpc/etherif.h /n/emeliedump/2000/0516/sys/src/9/mpc/etherif.h
2c
	MaxEther	= 4,
.
## diffname mpc/etherif.h 2001/0527 # deleted
## diff -e /n/emeliedump/2000/0516/sys/src/9/mpc/etherif.h /n/emeliedump/2001/0527/sys/src/9/mpc/etherif.h
1,28d
