## diffname mpc/fns.h 1999/0121
## diff -e /dev/null /n/emeliedump/1999/0121/sys/src/brazil/mpc/fns.h
0a
#include "../port/portfns.h"

void	archinit(void);
int	brgalloc(void);
void	brgfree(int);
ulong	baudgen(int, int);
int	cistrcmp(char*, char*);
int	cistrncmp(char*, char*, int);
void	clockcheck(void);
void	clockinit(void);
void	clockintr(Ureg*);
void	clrfptrap(void);
#define coherence()		// not need on signle processor machines
void	cpminit(void);
int	cpuidentify(void);
void	cpuidprint(void);
void	dcflush(void*, ulong);
void	delay(int);
ulong	draminit(ulong*);
void	dtlbmiss(void);
void	dumpregs(Ureg*);
void	eieio(void);
void	evenaddr(ulong);
void	faultpower(Ureg*);
void	firmware(int);
void	fpinit(void);
int	fpipower(Ureg*);
void	fpoff(void);
ulong	fpstatus(void);
char*	getconf(char*);
ulong	getdar(void);
ulong	getdec(void);
ulong	getdepn(void);
ulong	getdsisr(void);
ulong	getimmr(void);
ulong	getmsr(void);
ulong	getpvr(void);
ulong	gettbl(void);
ulong	gettbu(void);
void	gotopc(ulong);
void	icflush(void*, ulong);
void	idle(void);
int	iprint(char*, ...);
void	intr(Ureg*);
void	intrenable(int, void (*)(Ureg*, void*), void*, int);
int	intrstats(char*, int);
void	intrvec(void);
void	itlbmiss(void);
int	isaconfig(char*, int, ISAConf*);
void	kbdinit(void);
void	kbdreset(void);
void	links(void);
void	mapfree(RMap*, ulong, int);
void	mapinit(RMap*, Map*, int);
void	mathinit(void);
void	mmuinit(void);
ulong*	mmuwalk(ulong*, ulong, int);
#define	procrestore(p)
void	procsave(Proc*);
void	procsetup(Proc*);
void	putdec(ulong);
void	putmsr(ulong);
ulong	rmapalloc(RMap*, ulong, int, int);
void	screeninit(void);
void	setpanic(void);
int	screenprint(char*, ...);			/* debugging */
#define screenputs(x, y)		// no screen
ulong	sdraminit(ulong*);
int	segflush(void*, ulong);
void	spireset(void);
long	spioutin(void*, long, void*);
int	tas(void*);
void	trapinit(void);
void	trapvec(void);
void	uartinstall(void);
void	uartwait(void);	/* debugging */
void	wbflush(void);

#define	waserror()	(up->nerrlab++, setlabel(&up->errlab[up->nerrlab-1]))
ulong	getcallerpc(void*);

// identity map between kernel physical and virtual addresses
#define KADDR(a)	((void*)(a))
#define PADDR(a)	((ulong)(a))

/* IBM bit field order */
#define	IBIT(b)		((ulong)1<<(31-(b)))
#define	SIBIT(n)	((ushort)1<<(15-(n)))

/* compatibility with inf2.1 */
#define	bpenumenv(n)	((char*)0)
.
## diffname mpc/fns.h 1999/0122
## diff -e /n/emeliedump/1999/0121/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0122/sys/src/brazil/mpc/fns.h
91a

#define IOREGS(x, T)	((T*)((char*)m->iomem+(x)))
.
## diffname mpc/fns.h 1999/0126
## diff -e /n/emeliedump/1999/0122/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0126/sys/src/brazil/mpc/fns.h
51a
void	kernelmmu(void);
.
22c
//void	eieio(void);
#define	eieio()
.
13c
#define coherence()		// not need on single processor machines
.
## diffname mpc/fns.h 1999/0127
## diff -e /n/emeliedump/1999/0126/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0127/sys/src/brazil/mpc/fns.h
74a
void	touser(void*);
.
25c
void	faultpower(Ureg*, ulong addr, int read);
.
## diffname mpc/fns.h 1999/0327
## diff -e /n/emeliedump/1999/0127/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0327/sys/src/brazil/mpc/fns.h
43a
#define	idlehands()			/* nothing to do in the runproc */
.
## diffname mpc/fns.h 1999/0608
## diff -e /n/emeliedump/1999/0327/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0608/sys/src/brazil/mpc/fns.h
80a
int unsac(uchar *dst, uchar *src, int n, int nsrc);
.
60a
void	outb(int, int);
void	outsb(int, void*, int);
void	outs(int, ushort);
void	outss(int, void*, int);
void	outl(int, ulong);
void	outsl(int, void*, int);
int		pcmspecial(char*, ISAConf*);
void	pcmspecialclose(int);
.
49a
int	iprint(char*, ...);
.
45c
int	inb(int);
void	insb(int, void*, int);
ushort	ins(int);
void	inss(int, void*, int);
ulong	inl(int);
void	insl(int, void*, int);
.
22,23c
void	eieio(void);
//#define	eieio()
.
## diffname mpc/fns.h 1999/0623
## diff -e /n/emeliedump/1999/0608/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0623/sys/src/brazil/mpc/fns.h
72a
PCMmap*	pcmmap(int, ulong, int, int);
void	pcmunmap(int, PCMmap*);
.
## diffname mpc/fns.h 1999/0714
## diff -e /n/emeliedump/1999/0623/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0714/sys/src/brazil/mpc/fns.h
101d
## diffname mpc/fns.h 1999/0930
## diff -e /n/emeliedump/1999/0714/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/0930/sys/src/brazil/mpc/fns.h
21a
void	delayloopinit(void);
.
## diffname mpc/fns.h 1999/1210
## diff -e /n/emeliedump/1999/0930/sys/src/brazil/mpc/fns.h /n/emeliedump/1999/1210/sys/src/9/mpc/fns.h
45a
void	iofree(int);
void	ioinit(void);
int	iounused(int, int);
int	ioalloc(int, int, int, char*);
.
## diffname mpc/fns.h 2000/0516
## diff -e /n/emeliedump/1999/1210/sys/src/9/mpc/fns.h /n/emeliedump/2000/0516/sys/src/9/mpc/fns.h
106,109c
#define KADDR(a)	((void*)((ulong)(a)|KZERO))
#define PADDR(a)	((ulong)(a)&~KZERO)
.
99a
void	tlbflush(ulong);
void	tlbflushall(void);
.
96a
uchar*	tarlookup(uchar *addr, char *file, int *dlen);
.
86a
void	putcasid(ulong);
.
46,49d
20a
void	dtlberror(void);
.
## diffname mpc/fns.h 2000/0521
## diff -e /n/emeliedump/2000/0516/sys/src/9/mpc/fns.h /n/emeliedump/2000/0521/sys/src/9/mpc/fns.h
79a
void	powerdownled(void);
void	powerupled(void);
.
## diffname mpc/fns.h 2000/1106
## diff -e /n/emeliedump/2000/0521/sys/src/9/mpc/fns.h /n/emeliedump/2000/1106/sys/src/9/mpc/fns.h
105a
#define	userureg(ur) ((ur)->status & KUSER)
.
## diffname mpc/fns.h 2000/1111
## diff -e /n/emeliedump/2000/1106/sys/src/9/mpc/fns.h /n/emeliedump/2000/1111/sys/src/9/mpc/fns.h
91c
#define screenputs(x, y)
.
13c
#define coherence()
.
## diffname mpc/fns.h 2001/0527 # deleted
## diff -e /n/emeliedump/2000/1111/sys/src/9/mpc/fns.h /n/emeliedump/2001/0527/sys/src/9/mpc/fns.h
1,120d
