## diffname mtx/fns.h 2001/0810
## diff -e /dev/null /n/emeliedump/2001/0810/sys/src/9/mtx/fns.h
0a
#include "../port/portfns.h"

void	archinit(void);
int	brgalloc(void);
void	brgfree(int);
ulong	baudgen(int, int);
int	cistrcmp(char*, char*);
int	cistrncmp(char*, char*, int);
void	clockcheck(void);
void	clockinit(void);
void	clockintr(Ureg*);
void	clrfptrap(void);
#define coherence()
void	cpminit(void);
int	cpuidentify(void);
void	cpuidprint(void);
void	dcflush(void*, ulong);
void	delay(int);
ulong	draminit(ulong*);
void	dtlbmiss(void);
void	dtlberror(void);
void	dumpregs(Ureg*);
void	delayloopinit(void);
void	eieio(void);
//#define	eieio()
void	evenaddr(ulong);
void	faultpower(Ureg*, ulong addr, int read);
void	firmware(int);
void	fpinit(void);
int	fpipower(Ureg*);
void	fpoff(void);
ulong	fpstatus(void);
char*	getconf(char*);
ulong	getdar(void);
ulong	getdec(void);
ulong	getdepn(void);
ulong	getdsisr(void);
ulong	getimmr(void);
ulong	getmsr(void);
ulong	getpvr(void);
ulong	gettbl(void);
ulong	gettbu(void);
void	gotopc(ulong);
void	i8250console(void);
void	icflush(void*, ulong);
void	idle(void);
#define	idlehands()			/* nothing to do in the runproc */
int	inb(int);
void	insb(int, void*, int);
ushort	ins(int);
void	inss(int, void*, int);
ulong	inl(int);
void	insl(int, void*, int);
void	intr(Ureg*);
void	intrenable(int, void (*)(Ureg*, void*), void*, int, char*);
int	intrstats(char*, int);
void	intrvec(void);
int	iprint(char*, ...);
void	itlbmiss(void);
int	isaconfig(char*, int, ISAConf*);
void	kbdinit(void);
void	kbdreset(void);
void	kernelmmu(void);
void	links(void);
void	mathinit(void);
void	mmuinit(void);
ulong*	mmuwalk(ulong*, ulong, int);
void	outb(int, int);
void	outsb(int, void*, int);
void	outs(int, ushort);
void	outss(int, void*, int);
void	outl(int, ulong);
void	outsl(int, void*, int);
int		pcmspecial(char*, ISAConf*);
void	pcmspecialclose(int);
#define	procrestore(p)
void	powerdownled(void);
void	powerupled(void);
void	procsave(Proc*);
void	procsetup(Proc*);
void	putdec(ulong);
void	putmsr(ulong);
void	putcasid(ulong);
void	screeninit(void);
void	setpanic(void);
int	screenprint(char*, ...);			/* debugging */
ulong	sdraminit(ulong*);
int	segflush(void*, ulong);
void	spireset(void);
long	spioutin(void*, long, void*);
int	tas(void*);
uchar*	tarlookup(uchar *addr, char *file, int *dlen);
void	touser(void*);
void	trapinit(void);
void	trapvec(void);
void	tlbflush(ulong);
void	tlbflushall(void);
void	uartinstall(void);
void	uartwait(void);	/* debugging */
int unsac(uchar *dst, uchar *src, int n, int nsrc);
#define	userureg(ur) ((ur)->status & KUSER)
void	wbflush(void);

#define	waserror()	(up->nerrlab++, setlabel(&up->errlab[up->nerrlab-1]))
#define KADDR(a)	((void*)((ulong)(a)|KZERO))
#define PADDR(a)	((ulong)(a)&~KZERO)
.
## diffname mtx/fns.h 2001/1122
## diff -e /n/emeliedump/2001/0810/sys/src/9/mtx/fns.h /n/emeliedump/2001/1122/sys/src/9/mtx/fns.h
101c
#define	userureg(ur) (((ur)->status & MSR_PR) != 0)
.
63a
#define	kmapinval()
.
## diffname mtx/fns.h 2001/1208
## diff -e /n/emeliedump/2001/1122/sys/src/9/mtx/fns.h /n/emeliedump/2001/1208/sys/src/9/mtx/fns.h
28c
void	firmware(void);
.
25d
15c
void	cpuidentify(void);
.
## diffname mtx/fns.h 2001/1215
## diff -e /n/emeliedump/2001/1208/sys/src/9/mtx/fns.h /n/emeliedump/2001/1215/sys/src/9/mtx/fns.h
83a
void	raveninit(void);
.
73a
int	pciscan(int, Pcidev **);
ulong pcibarsize(Pcidev *, int);
int	pcicfgr8(Pcidev*, int);
int	pcicfgr16(Pcidev*, int);
int	pcicfgr32(Pcidev*, int);
void	pcicfgw8(Pcidev*, int, int);
void	pcicfgw16(Pcidev*, int, int);
void	pcicfgw32(Pcidev*, int, int);
void pciclrbme(Pcidev*);
void	pcihinv(Pcidev*);
uchar pciipin(Pcidev *, uchar);
Pcidev* pcimatch(Pcidev*, int, int);
Pcidev* pcimatchtbdf(int);
void	pcireset(void);
void	pcisetbme(Pcidev*);
.
67a
void	mpicenable(int);
void	mpiceoi(void);
int	mpicintack(void);
.
## diffname mtx/fns.h 2001/1218
## diff -e /n/emeliedump/2001/1215/sys/src/9/mtx/fns.h /n/emeliedump/2001/1218/sys/src/9/mtx/fns.h
119d
111d
108,109d
106d
104d
95,96d
92,93d
68,69c
void	mpicdisable(int);
void	mpicenable(int, Vctl*);
int	mpiceoi(int);
.
58d
55,56c
int	ioalloc(int, int, int, char*);
void	ioinit(void);
.
43a
void	i8259init(void);
int	i8259intack(void);
int	i8259enable(Vctl*);
int	i8259vecno(int);
int	i8259disable(int);
.
42a
void	hwintrinit(void);
.
19,21d
14d
4,6d
## diffname mtx/fns.h 2001/1222
## diff -e /n/emeliedump/2001/1218/sys/src/9/mtx/fns.h /n/emeliedump/2001/1222/sys/src/9/mtx/fns.h
96c
void	putsdr1(ulong);
.
## diffname mtx/fns.h 2002/0108
## diff -e /n/emeliedump/2001/1222/sys/src/9/mtx/fns.h /n/emeliedump/2002/0108/sys/src/9/mtx/fns.h
100a
void	sync(void);
.
96a
void	putsr(int, ulong);
.
69a
int	newmmupid(void);
.
## diffname mtx/fns.h 2002/0112
## diff -e /n/emeliedump/2002/0108/sys/src/9/mtx/fns.h /n/emeliedump/2002/0112/sys/src/9/mtx/fns.h
95a
void	puthid0(ulong);
void	puthid1(ulong);
.
29a
ulong	gethid0(void);
ulong	gethid1(void);
.
22,24c
void	fpoff(Proc*);
void	fprestore(FPsave*);
void	fpsave(FPsave*);
void	fptrap(Ureg*);
.
9,10c
#define coherence()	eieio()
.
## diffname mtx/fns.h 2002/0116
## diff -e /n/emeliedump/2002/0112/sys/src/9/mtx/fns.h /n/emeliedump/2002/0116/sys/src/9/mtx/fns.h
56a
void	iofree(int);
.
## diffname mtx/fns.h 2002/0124
## diff -e /n/emeliedump/2002/0116/sys/src/9/mtx/fns.h /n/emeliedump/2002/0124/sys/src/9/mtx/fns.h
21d
## diffname mtx/fns.h 2002/0126
## diff -e /n/emeliedump/2002/0124/sys/src/9/mtx/fns.h /n/emeliedump/2002/0126/sys/src/9/mtx/fns.h
116a
void	watchreset(void);
.
94c
#define procrestore(p)
.
19d
## diffname mtx/fns.h 2002/0212
## diff -e /n/emeliedump/2002/0126/sys/src/9/mtx/fns.h /n/emeliedump/2002/0212/sys/src/9/mtx/fns.h
66c
void	mmusweep(void*);
.
## diffname mtx/fns.h 2002/0404
## diff -e /n/emeliedump/2002/0212/sys/src/9/mtx/fns.h /n/emeliedump/2002/0404/sys/src/9/mtx/fns.h
35a
int	havecycintr(void);
.
9a
void	cycintradd(Cycintr *);
void	cycintrdel(Cycintr *);
.
8a
void	clockintrsched(void);
.
## diffname mtx/fns.h 2002/0405
## diff -e /n/emeliedump/2002/0404/sys/src/9/mtx/fns.h /n/emeliedump/2002/0405/sys/src/9/mtx/fns.h
39c
int	havetimer(void);
.
11,12c
void	timeradd(Timer *);
void	timerdel(Timer *);
.
