## diffname port/devrealtime.h 2002/0316
## diff -e /dev/null /n/emeliedump/2002/0316/sys/src/9/port/devrealtime.h
0a
#define Onemicrosecond			((Time)1000ULL)
#define Onemillisecond			((Time)1000*Onemicrosecond)
#define Onesecond				((Time)1000*Onemillisecond)

typedef vlong	Time;
typedef struct Schedevent Schedevent;

enum SEvent {
	SAdmit,		/* new proc arrives*/
	SRelease,		/* released, but not yet scheduled (on qreleased) */
	SRun,		/* one of this task's procs started running */
	SPreempt,		/* the running proc was preempted */
	SBlock,		/* none of the procs are runnable as a result of sleeping */
	SResume,		/* one or more procs became runnable */
	SDeadline,	/* proc's deadline */
	SYield,		/* proc reached voluntary early deadline */
	SSlice,		/* slice exhausted */
	SExpel,		/* proc is gone */
};
typedef enum SEvent	SEvent;

struct Schedevent {
	ulong	tid;		// Task ID
	Time		ts;		// Event time
	SEvent	etype;	// Event type
};

.
## diffname port/devrealtime.h 2002/0320
## diff -e /n/emeliedump/2002/0316/sys/src/9/port/devrealtime.h /n/emeliedump/2002/0320/sys/src/9/port/devrealtime.h
23,25c
	ushort	tid;		/* Task ID */
	SEvent	etype;	/* Event type */
	Time		ts;		/* Event time */
.
5,7d
0a

typedef vlong	Time;
typedef struct	Schedevent Schedevent;

.
## diffname port/devrealtime.h 2002/0927 # deleted
## diff -e /n/emeliedump/2002/0320/sys/src/9/port/devrealtime.h /n/emeliedump/2002/0927/sys/src/9/port/devrealtime.h
1,28d
