## diffname port/error.h 1992/0111
## diff -e /dev/null /n/bootesdump/1992/0111/sys/src/9/port/error.h
0a
extern char Enoerror[];		/* no error */
extern char Emount[];		/* inconsistent mount */
extern char Eunmount[];		/* not mounted */
extern char Eunion[];		/* not in union */
extern char Enocreate[];	/* mounted directory forbids creation */
extern char Enonexist[];	/* file does not exist */
extern char Ebadsharp[];	/* unknown device in # filename */
extern char Enotdir[];		/* not a directory */
extern char Eisdir[];		/* file is a directory */
extern char Ebadchar[];		/* bad character in file name */
extern char Efilename[];	/* file name syntax */
extern char Eperm[];		/* permission denied */
extern char Ebadusefd[];	/* inappropriate use of fd */
extern char Ebadarg[];		/* bad arg in system call */
extern char Einuse[];		/* device or object already in use */
extern char Eio[];		/* i/o error */
extern char Etoobig[];		/* read or write too large */
extern char Etoosmall[];	/* read or write too small */
extern char Ebadblt[];		/* bad bitblt or bitmap request */
extern char Ebadbitmap[];	/* unallocated bitmap */
extern char Enobitmap[];	/* out of bitmap descriptors */
extern char Enobitstore[];	/* out of bitmap storage */
extern char Ebadfont[];		/* unallocated font */
extern char Enofont[];		/* out of font descriptors */
extern char Eauth[];		/* authentication failure */
extern char Eaddrnotfound[];	/* network address not found */
extern char Emsgsize[];		/* message is too big for protocol */
extern char Enetbusy[];		/* network device is busy or allocated */
extern char Enoifc[];		/* bad interface or no free interface slots */
extern char Ehungup[];		/* write to hungup stream */
extern char Enodev[];		/* no free devices */
extern char Enoenv[];		/* no free environment resources */

extern char Enofd[];		/* no free file descriptors */
extern char Ebadfd[];		/* fd out of range or not open */
extern char Ebadexec[];		/* a.out header invalid */
extern char Eioload[];		/* i/o error in demand load */
extern char Enochild[];		/* no living children */
extern char Enoseg[];		/* no free segments */
extern char Ebadmount[];	/* inconsistent mount */
extern char Enomount[];		/* mount table full */
extern char Enomntdev[];	/* no free mount devices */
extern char Eshutdown[];	/* mounted device shut down */
extern char Ebaddirread[];	/* directory read not quantized */
extern char Esegaddr[];		/* illegal segment addresses or size */
extern char Eprocdied[];	/* process exited */
extern char Enosrv[];		/* no free server slots */
extern char Enoqueue[];		/* no free stream queues */
extern char Ebadld[];		/* illegal line discipline */
extern char Enostream[];	/* no free stream heads */
extern char Ebadnet[];		/* illegal network address */
extern char Ebadctl[];		/* bad process or stream control request */
extern char Enonote[];		/* note overflow */
extern char Eintr[];		/* interrupted */
extern char Edestbusy[];	/* datakit destination busy */
extern char Edestotl[];		/* datakit destination out to lunch */
extern char Enetotl[];		/* datakit controller out to lunch */
extern char Erejected[];	/* datakit destination rejected call */
extern char Eshortmsg[];	/* short message */
extern char Ebadmsg[];		/* format error or mismatch in message */
extern char Ebadcnt[];		/* read count greater than requested */
extern char Enovmem[];		/* virtual memory allocation failed */
extern char Enoasync[];		/* out of async stream modules */
extern char Enopipe[];		/* out of pipes */
extern char Enoport[];		/* network port not available */
extern char Enetunreach[];	/* network unreachable */
extern char Etimedout[];	/* connection timed out */
extern char Econrefused[];	/* connection refused */
extern char Enoproto[];		/* network protocol not supported */
extern char Eprotonosup[];	/* operation not supported by network protocol */
extern char Eisstream[];	/* seek on a stream */
extern char Enofilsys[];	/* out of filsys resources */
extern char Egreg[];		/* it's a thermal problem */
.
## diffname port/error.h 1992/0112
## diff -e /n/bootesdump/1992/0111/sys/src/9/port/error.h /n/bootesdump/1992/0112/sys/src/9/port/error.h
69d
65d
29a
extern char Enolisten[];	/* not announced */
.
28a
extern char Enoproto[];		/* network protocol not supported */
extern char Enoport[];		/* network port not available */
extern char Enoroute[];		/* no free routes */
.
26c
extern char Ebadaddr[];		/* bad network address */
.
## diffname port/error.h 1992/0113
## diff -e /n/bootesdump/1992/0112/sys/src/9/port/error.h /n/bootesdump/1992/0113/sys/src/9/port/error.h
68d
63,64d
56d
45,47d
36a
extern char Emuxshutdown[];	/* mux server shut down */
extern char Emuxbusy[];		/* all mux channels busy */
extern char Enomux[];		/* no free multiplexers */
extern char Emuxmsg[];		/* bad mux message format or mismatch */
extern char Enopipe[];		/* no free pipes */
.
34a
extern char Ebadctl[];		/* bad process or stream control request */
.
24c
extern char Enofont[];		/* no free font descriptors */
.
4a
extern char Emountrpc[];	/* mount rpc error */
extern char Eshutdown[];	/* mounted device shut down */
extern char Enomntdev[];	/* no free mount devices */
.
## diffname port/error.h 1992/0114
## diff -e /n/bootesdump/1992/0113/sys/src/9/port/error.h /n/bootesdump/1992/0114/sys/src/9/port/error.h
74,76c
extern char Enetunreach[];	/* network unreachable */
extern char Eintr[];		/* interrupted */
.
70,71c
extern char Ebadld[];		/* illegal line discipline */
extern char Ebadfd[];		/* fd out of range or not open */
extern char Eisstream[];	/* seek on a stream */
extern char Ebadexec[];		/* a.out header invalid */
.
57,68c
extern char Enochild[];		/* no living children */
extern char Eioload[];		/* i/o error in demand load */
.
45,55d
43d
34d
28,29c
extern char Enetaddr[];		/* bad network address */
.
7d
## diffname port/error.h 1992/0122
## diff -e /n/bootesdump/1992/0114/sys/src/9/port/error.h /n/bootesdump/1992/0122/sys/src/9/port/error.h
48c
extern char Ebadexec[];		/* exec header invalid */
.
## diffname port/error.h 1992/0528
## diff -e /n/bootesdump/1992/0122/sys/src/9/port/error.h /n/bootesdump/1992/0528/sys/src/9/port/error.h
52a
extern char Eneedservice[];	/* service required for tcp/udp/il calls */
.
## diffname port/error.h 1992/0622
## diff -e /n/bootesdump/1992/0528/sys/src/9/port/error.h /n/bootesdump/1992/0622/sys/src/9/port/error.h
53a
extern char Enomem[];		/* kernel allocate failed */
.
26d
## diffname port/error.h 1992/06271
## diff -e /n/bootesdump/1992/0622/sys/src/9/port/error.h /n/bootesdump/1992/06271/sys/src/9/port/error.h
53a
extern char Esfnotcached[];	/* subfont not cached */
.
## diffname port/error.h 1992/0824
## diff -e /n/bootesdump/1992/06271/sys/src/9/port/error.h /n/bootesdump/1992/0824/sys/src/9/port/error.h
55a
extern char Esoverlap[];	/* segments overlap */
.
## diffname port/error.h 1992/1017
## diff -e /n/bootesdump/1992/0824/sys/src/9/port/error.h /n/bootesdump/1992/1017/sys/src/9/port/error.h
56a
extern char Emouseset[];	/* mouse type already set */
.
## diffname port/error.h 1993/0501
## diff -e /n/bootesdump/1992/1017/sys/src/9/port/error.h /n/fornaxdump/1993/0501/sys/src/brazil/port/error.h
57a
extern char Erecover[];		/* failed to recover fd */
.
## diffname port/error.h 1993/0818
## diff -e /n/fornaxdump/1993/0501/sys/src/brazil/port/error.h /n/fornaxdump/1993/0818/sys/src/brazil/port/error.h
58a
extern char Egreg[];		/* coherency problem */
.
55d
## diffname port/error.h 1993/1006
## diff -e /n/fornaxdump/1993/0818/sys/src/brazil/port/error.h /n/fornaxdump/1993/1006/sys/src/brazil/port/error.h
57a
extern char Eshort[];		/* i/o count too small */
.
21,25d
## diffname port/error.h 1993/1116
## diff -e /n/fornaxdump/1993/1006/sys/src/brazil/port/error.h /n/fornaxdump/1993/1116/sys/src/brazil/port/error.h
53a
extern char Enobitstore[];	/* out of screen memory */
.
## diffname port/error.h 1994/0622
## diff -e /n/fornaxdump/1993/1116/sys/src/brazil/port/error.h /n/fornaxdump/1994/0622/sys/src/brazil/port/error.h
55a
extern char Ebadspec[];		/* bad attach specifier */
.
## diffname port/error.h 1994/0828
## diff -e /n/fornaxdump/1994/0622/sys/src/brazil/port/error.h /n/fornaxdump/1994/0828/sys/src/brazil/port/error.h
28c
extern char Ehungup[];		/* write to hungup channel */
.
## diffname port/error.h 1995/0108
## diff -e /n/fornaxdump/1994/0828/sys/src/brazil/port/error.h /n/fornaxdump/1995/0108/sys/src/brazil/port/error.h
55c
extern char Egreg[];		/* ken scheduled it */
.
## diffname port/error.h 1995/0207
## diff -e /n/fornaxdump/1995/0108/sys/src/brazil/port/error.h /n/fornaxdump/1995/0207/sys/src/brazil/port/error.h
29c
extern char Ebadctl[];		/* bad process or channel control request */
.
## diffname port/error.h 1997/1206
## diff -e /n/fornaxdump/1995/0207/sys/src/brazil/port/error.h /n/emeliedump/1997/1206/sys/src/brazil/port/error.h
56a
extern char Enoreg[];		/* process has no saved registers */
.
54d
## diffname port/error.h 1999/0120
## diff -e /n/emeliedump/1997/1206/sys/src/brazil/port/error.h /n/emeliedump/1999/0120/sys/src/brazil/port/error.h
48a
extern char Enoswap[];		/* swap space full */
.
## diffname port/error.h 1999/0122
## diff -e /n/emeliedump/1999/0120/sys/src/brazil/port/error.h /n/emeliedump/1999/0122/sys/src/brazil/port/error.h
8a
extern char Eexist[];		/* file already exists */
.
## diffname port/error.h 1999/1104
## diff -e /n/emeliedump/1999/0122/sys/src/brazil/port/error.h /n/emeliedump/1999/1104/sys/src/9/port/error.h
56c
extern char Egreg[];		/* xterm: Error 50, errno 1: Too big */
.
## diffname port/error.h 1999/1105
## diff -e /n/emeliedump/1999/1104/sys/src/9/port/error.h /n/emeliedump/1999/1105/sys/src/9/port/error.h
54d
## diffname port/error.h 2000/0215
## diff -e /n/emeliedump/1999/1105/sys/src/9/port/error.h /n/emeliedump/2000/0215/sys/src/9/port/error.h
41a
extern char Enofd[];			/* no free file descriptors */
.
## diffname port/error.h 2000/0322
## diff -e /n/emeliedump/2000/0215/sys/src/9/port/error.h /n/emeliedump/2000/0322/sys/src/9/port/error.h
58a
extern char Enoattach[];	/* mount/attach disallowed */
.
## diffname port/error.h 2000/0324
## diff -e /n/emeliedump/2000/0322/sys/src/9/port/error.h /n/emeliedump/2000/0324/sys/src/9/port/error.h
52d
49d
47d
40d
32,35d
27,28d
22,25d
## diffname port/error.h 2000/1215
## diff -e /n/emeliedump/2000/0324/sys/src/9/port/error.h /n/emeliedump/2000/1215/sys/src/9/port/error.h
45a
extern char Ectlsyntax[];	/* bad syntax in control file messages */
.
## diffname port/error.h 2000/1220
## diff -e /n/emeliedump/2000/1215/sys/src/9/port/error.h /n/emeliedump/2000/1220/sys/src/9/port/error.h
35a
extern char Econinuse[];	/* connection in use */
.
## diffname port/error.h 2001/0115
## diff -e /n/emeliedump/2000/1220/sys/src/9/port/error.h /n/emeliedump/2001/0115/sys/src/9/port/error.h
47d
## diffname port/error.h 2001/0527
## diff -e /n/emeliedump/2001/0115/sys/src/9/port/error.h /n/emeliedump/2001/0527/sys/src/9/port/error.h
46a
extern char Eshortstat[];	/* stat buffer too small */
extern char Ebadstat[];		/* malformed stat buffer */
.
43c
extern char Egreg[];		/* ken has left the building */
.
## diffname port/error.h 2001/0528
## diff -e /n/emeliedump/2001/0527/sys/src/9/port/error.h /n/emeliedump/2001/0528/sys/src/9/port/error.h
48a
extern char Enegoff[];	/* negative i/o offset */
.
## diffname port/error.h 2001/0619
## diff -e /n/emeliedump/2001/0528/sys/src/9/port/error.h /n/emeliedump/2001/0619/sys/src/9/port/error.h
49c
extern char Enegoff[];		/* negative i/o offset */
.
31c
extern char Enofd[];		/* no free file descriptors */
.
23c
extern char Ehungup[];		/* i/o on hungup channel */
.
## diffname port/error.h 2001/0819
## diff -e /n/emeliedump/2001/0619/sys/src/9/port/error.h /n/emeliedump/2001/0819/sys/src/9/port/error.h
6c
extern char Eshutdown[];	/* device shut down */
.
## diffname port/error.h 2001/1118
## diff -e /n/emeliedump/2001/0819/sys/src/9/port/error.h /n/emeliedump/2001/1118/sys/src/9/port/error.h
24a
extern char Eargctl[];		/* wrong number of arguments in control request */
.
## diffname port/error.h 2001/1120
## diff -e /n/emeliedump/2001/1118/sys/src/9/port/error.h /n/emeliedump/2001/1120/sys/src/9/port/error.h
50a
extern char Ecmdargs[];		/* wrong #args in control message */
.
25d
## diffname port/error.h 2003/0509
## diff -e /n/emeliedump/2001/1120/sys/src/9/port/error.h /n/emeliedump/2003/0509/sys/src/9/port/error.h
3a
extern char Eismtpt[];		/* is a mount point */
.
