## diffname port/streboot.c 1992/0303
## diff -e /dev/null /n/bootesdump/1992/0303/sys/src/9/port/streboot.c
0a
#include	"u.h"
#include	"lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

/*
 *  reboot stream module definition
 */
static void rebootopen(Queue*, Stream*);
static void rebootiput(Queue*, Block*);
static void rebootoput(Queue*, Block*);
static void rebootreset(void);
Qinfo rebootinfo =
{
	rebootiput,
	rebootoput,
	rebootopen,
	0,
	"reboot",
	0
};

static void
rebootopen(Queue *q, Stream *s)
{
	USED(q);
	if(strcmp(u->p->user, eve) != 0)
		error(Eperm);
}

void
rebootoput(Queue *q, Block *bp)
{
	PUTNEXT(q, bp);
}

static void
rebootiput(Queue *q, Block *bp)
{
	if(bp->type == M_HANGUP){
		print("lost connection to fs, rebooting");
		exit();
	}
	PUTNEXT(q, bp);
}
.
## diffname port/streboot.c 1992/0321
## diff -e /n/bootesdump/1992/0303/sys/src/9/port/streboot.c /n/bootesdump/1992/0321/sys/src/9/port/streboot.c
2c
#include	"../port/lib.h"
.
## diffname port/streboot.c 1992/0711
## diff -e /n/bootesdump/1992/0321/sys/src/9/port/streboot.c /n/bootesdump/1992/0711/sys/src/9/port/streboot.c
28a
	USED(s);
.
## diffname port/streboot.c 1992/0812
## diff -e /n/bootesdump/1992/0711/sys/src/9/port/streboot.c /n/bootesdump/1992/0812/sys/src/9/port/streboot.c
45c
		exit(0);
.
## diffname port/streboot.c 1993/0501
## diff -e /n/bootesdump/1992/0812/sys/src/9/port/streboot.c /n/fornaxdump/1993/0501/sys/src/brazil/port/streboot.c
30c
	if(strcmp(up->user, eve) != 0)
.
## diffname port/streboot.c 1993/0804 # deleted
## diff -e /n/fornaxdump/1993/0501/sys/src/brazil/port/streboot.c /n/fornaxdump/1993/0804/sys/src/brazil/port/streboot.c
1,48d
