## diffname power/fns.h 1990/0227
## diff -e /dev/null /n/bootesdump/1990/0227/sys/src/9/mips/fns.h
0a
Alarm	*alarm(int, void (*)(Alarm*), void*);
void	alarminit(void);
Block	*allocb(ulong);
void	append(List**, List*);
void	cancel(Alarm*);
int	canlock(Lock*);
int	canqlock(QLock*);
void	chaninit(void);
void	chandevreset(void);
void	chandevinit(void);
void	clock(ulong);
void	clockinit(void);
Chan	*clone(Chan*, Chan*);
void	close(Chan*);
void	closemount(Mount*);
void	closepgrp(Pgrp*);
long	clrfpintr(void);
void	compactpte(Orig*, ulong);
void	confinit(void);
int	consactive(void);
int	conschar(void);
void	consoff(void);
int	consputc(int);
Env	*copyenv(Env*, int);
int	decref(Ref*);
void	delay(int);
void	delete(List**, List*, List*);
void	delete0(List**, List*);
Chan	*devattach(int, char*);
Chan	*devclone(Chan*, Chan*);
void	devdir(Chan*, long, char*, long, long, Dir*);
long	devdirread(Chan*, char*, long, Dirtab*, int, Devgen*);
Devgen	devgen;
int	devno(int, int);
Chan*	devopen(Chan*, int, Dirtab*, int, Devgen*);
void	devstat(Chan*, char*, Dirtab*, int, Devgen*);
int	devwalk(Chan*, char*, Dirtab*, int, Devgen*);
void	duartinit(void);
void	duartintr(void);
int	duartputc(int);
void	duartreset(void);
void	duartxmit(int);
void	dumpregs(Ureg*);
void	dumpstack(void);
int	eqchan(Chan*, Chan*, long);
void	envpgclose(Env*);
void	error(Chan*, int);
void	evenaddr(ulong);
void	exit(void);
void	fault(Ureg*, int, int);
Chan*	fdtochan(int, int);
void	firmware(void);
void	flowctl(Queue*);
void	flushmmu(void);
void	forkmod(Seg*, Seg*, Proc*);
void	freeb(Block*);
void	freepage(Orig*);
void	freepte(Orig*);
void	freesegs(int);
void	freealarm(Alarm*);
Block	*getb(Blist*);
Block	*getq(Queue*);
void	gettlb(int, ulong*);
ulong	gettlbvirt(int);
void	gotolabel(Label*);
void	growpte(Orig*, ulong);
void	*ialloc(ulong, int);
int	incref(Ref*);
void	insert(List**, List*, List*);
void	intr(ulong);
void	io2init(void);
void	isdir(Chan*);
void	kbdchar(int);
void	kproc(char*, void(*)(void*), void*);
void	launchinit(void);
void	lancereset(void);
void	lanceinit(void);
void	lanceintr(void);
void	lanceparity(void);
void	lanceinit(void);
void	launch(int);
void	lights(int);
void	lock(Lock*);
void	lockinit(void);
Orig	*lookorig(ulong, ulong, int, Chan*);
void	machinit(void);
void	mapstack(Proc*);
int	mount(Chan*, Chan*, int);
Chan	*namec(char*, int, int, ulong);
void	nexterror(void);
Alarm	*newalarm(void);
Chan	*newchan(void);
PTE	*newmod(void);
Mount	*newmount(void);
Orig	*neworig(ulong, ulong, int, Chan*);
Page	*newpage(int, Orig*, ulong);
Pgrp	*newpgrp(void);
Proc	*newproc(void);
char	*nextelem(char*, char*);
void	newstart(void);
int	newtlbpid(Proc*);
void	novme(int);
void	nullput(Queue*, Block*);
void	online(void);
int	openmode(ulong);
void	pageinit(void);
void	panic(char*, ...);
void	pexit(char*, int);
void	pgrpcpy(Pgrp*, Pgrp*);
void	pgrpinit(void);
int	postnote(Proc*, int, char*, int);
int	pprint(char*, ...);
void	prflush(void);
void	printinit(void);
void	printslave(void);
void	procinit0(void);
Proc	*proctab(int);
void	purgetlb(int);
Queue*	pushq(Stream*, Qinfo*);
void	putmmu(ulong, ulong);
void	puttlb(ulong, ulong);
void	puttlbx(int, ulong, ulong);
int	putb(Blist*, Block*);
int	putq(Queue*, Block*);
void	putstrn(char*, long);
ulong	pwait(Waitmsg*);
int	readnum(ulong, char*, ulong, ulong, int);
void	ready(Proc*);
void	rooterrstr(Error*, char*);
void	qlock(QLock*);
void	qunlock(QLock*);
void	restfpregs(FPsave*);
int	return0(void*);
Proc	*runproc(void);
void	savefpregs(FPsave*);
void	sched(void);
void	schedinit(void);
long	seconds(void);
Seg	*seg(Proc*, ulong);
int	segaddr(Seg*, ulong, ulong);
int	setlabel(Label*);
void	setvmevec(int, void (*)(int));
char*	skipslash(char*);
void	sleep(Rendez*, int(*)(void*), void*);
int	splhi(void);
int	spllo(void);
void	splx(int);
Devgen	streamgen;
void	streamclose(Chan*);
void	streaminit(void);
long	streamread(Chan*, void*, long);
long	streamwrite(Chan*, void*, long);
Stream*	streamnew(Chan*, Qinfo*);
void	streamopen(Chan*, Qinfo*);
int	streamparse(char*, Block*);
long	stringread(Chan*, void*, long, char*);
long	syscall(Ureg*);
void	tlbinit(void);
void	touser(void);
void	tsleep(Rendez*, int (*)(void*), void*, int);
void	twakeme(Alarm*);
void	unlock(Lock*);
void	usepage(Page*, int);
void	userinit(void);
void	validaddr(ulong, ulong, int);
void	vecinit(void);
void	vector80(void);
void*	vmemchr(void*, int, int);
void	wakeme(Alarm*);
void	wakeup(Rendez*);
void	wbflush(void);

#define	waserror()	setlabel(&u->errlab[u->nerrlab++])
#define	poperror()	u->nerrlab--
.
## diffname power/fns.h 1990/0312
## diff -e /n/bootesdump/1990/0227/sys/src/9/mips/fns.h /n/bootesdump/1990/0312/sys/src/9/mips/fns.h
152c
long	streamwrite(Chan*, void*, long, int);
.
123a
void	putbq(Blist*, Block*);
.
112a
Block	*prepend(Block*, int);
.
61a
int	getfields(char*, char**, int, char);
.
## diffname power/fns.h 1990/0321
## diff -e /n/bootesdump/1990/0312/sys/src/9/mips/fns.h /n/bootesdump/1990/0321/sys/src/9/mips/fns.h
99a
void	newqinfo(Qinfo*);
.
## diffname power/fns.h 1990/0419
## diff -e /n/bootesdump/1990/0321/sys/src/9/mips/fns.h /n/bootesdump/1990/0419/sys/src/9/mips/fns.h
66a
void	gotopc(void*);
.
## diffname power/fns.h 1990/0424
## diff -e /n/bootesdump/1990/0419/sys/src/9/mips/fns.h /n/bootesdump/1990/0424/sys/src/9/mips/fns.h
67c
void	gotopc(ulong);
.
4a
void	arginit(void);
.
## diffname power/fns.h 1990/0427
## diff -e /n/bootesdump/1990/0424/sys/src/9/mips/fns.h /n/bootesdump/1990/0427/sys/src/9/mips/fns.h
165c
void	touser(void *);
.
## diffname power/fns.h 1990/0504
## diff -e /n/bootesdump/1990/0427/sys/src/9/mips/fns.h /n/bootesdump/1990/0504/sys/src/9/mips/fns.h
70a
void	icflush(void *, int);
.
20a
void	confread(void);
void	confset(char*);
.
19a
ulong	confeval(char*);
void	confprint(void);
.
## diffname power/fns.h 1990/0629
## diff -e /n/bootesdump/1990/0504/sys/src/9/mips/fns.h /n/bootesdump/1990/0629/sys/src/9/mips/fns.h
160a
int	streamenter(Stream*);
void	streamexit(Stream*, int);
.
110a
int	nonetcksum(Block*, int);
void	nonetfreeifc(Noifc*);
Noifc*	nonetnewifc(Queue*, Stream*, int, int, int, void (*)(Noconv*, char*));
void	nonetrcvmsg(Noconv*, Block*);
.
## diffname power/fns.h 1990/0717
## diff -e /n/bootesdump/1990/0629/sys/src/9/mips/fns.h /n/bootesdump/1990/0717/sys/src/9/mips/fns.h
181a
void	urpreset(void);
.
## diffname power/fns.h 1990/0718
## diff -e /n/bootesdump/1990/0717/sys/src/9/mips/fns.h /n/bootesdump/1990/0718/sys/src/9/mips/fns.h
174a
void	sysloginit(void);
void	syslog(char*, int);
.
## diffname power/fns.h 1990/0720
## diff -e /n/bootesdump/1990/0718/sys/src/9/mips/fns.h /n/bootesdump/1990/0720/sys/src/9/mips/fns.h
141a
int	readlog(ulong, char*, ulong);
.
## diffname power/fns.h 1990/0731
## diff -e /n/bootesdump/1990/0720/sys/src/9/mips/fns.h /n/bootesdump/1990/0731/sys/src/9/mips/fns.h
78c
void	intr(ulong, ulong);
.
12c
void	clock(ulong, ulong);
.
## diffname power/fns.h 1990/0801
## diff -e /n/bootesdump/1990/0731/sys/src/9/mips/fns.h /n/bootesdump/1990/0801/sys/src/9/mips/fns.h
182a
void	unusepage(Page*, int);
.
173a
void	streamstat(Chan*, char*, char*);
.
## diffname power/fns.h 1990/0802
## diff -e /n/bootesdump/1990/0801/sys/src/9/mips/fns.h /n/bootesdump/1990/0802/sys/src/9/mips/fns.h
19c
int	compactpte(Orig*, ulong);
.
## diffname power/fns.h 1990/08141
## diff -e /n/bootesdump/1990/0802/sys/src/9/mips/fns.h /n/bootesdump/1990/08141/sys/src/9/mips/fns.h
55a
void	fdclose(int);
.
## diffname power/fns.h 1990/0826
## diff -e /n/bootesdump/1990/08141/sys/src/9/mips/fns.h /n/bootesdump/1990/0826/sys/src/9/mips/fns.h
83a
void	lance3intr(void);
.
80c
void	ioboardid(void);
void	ioboardinit(void);
.
## diffname power/fns.h 1990/0905
## diff -e /n/bootesdump/1990/0826/sys/src/9/mips/fns.h /n/bootesdump/1990/0905/sys/src/9/mips/fns.h
99a
void	mpbuserror(void);
.
## diffname power/fns.h 1990/09051
## diff -e /n/bootesdump/1990/0905/sys/src/9/mips/fns.h /n/bootesdump/1990/09051/sys/src/9/mips/fns.h
167a
void	sunmap(int, uchar*);
.
164a
uchar*	smap(int, uchar*);
.
162a
void	sinit(void);
.
## diffname power/fns.h 1990/0907
## diff -e /n/bootesdump/1990/09051/sys/src/9/mips/fns.h /n/bootesdump/1990/0907/sys/src/9/mips/fns.h
100d
45a
void	duartputs(char*);
.
## diffname power/fns.h 1990/0911
## diff -e /n/bootesdump/1990/0907/sys/src/9/mips/fns.h /n/bootesdump/1990/0911/sys/src/9/mips/fns.h
194d
122a
Block*	padb(Block*, int);
.
86d
81d
## diffname power/fns.h 1990/1009
## diff -e /n/bootesdump/1990/0911/sys/src/9/mips/fns.h /n/bootesdump/1990/1009/sys/src/9/mips/fns.h
177c
Stream*	streamnew(ushort, ushort, ushort, Qinfo*, int);
.
171a
void	streamclose1(Stream*);
.
## diffname power/fns.h 1990/1013
## diff -e /n/bootesdump/1990/1009/sys/src/9/mips/fns.h /n/bootesdump/1990/1013/sys/src/9/mips/fns.h
103c
PTE	*newmod(Orig*);
.
## diffname power/fns.h 1990/1101
## diff -e /n/bootesdump/1990/1013/sys/src/9/mips/fns.h /n/bootesdump/1990/1101/sys/src/9/mips/fns.h
174c
int	streamexit(Stream*, int);
.
63a
int	freebroken(void);
.
## diffname power/fns.h 1990/1110
## diff -e /n/bootesdump/1990/1101/sys/src/9/mips/fns.h /n/bootesdump/1990/1110/sys/src/9/mips/fns.h
127a
void	pgrpnote(Pgrp*, char*, long, int);
Pgrp	*pgrptab(int);
.
## diffname power/fns.h 1990/11161
## diff -e /n/bootesdump/1990/1110/sys/src/9/mips/fns.h /n/bootesdump/1990/11161/sys/src/9/mips/fns.h
200a
void	vmereset(void);
.
## diffname power/fns.h 1990/11211
## diff -e /n/bootesdump/1990/11161/sys/src/9/mips/fns.h /n/bootesdump/1990/11211/sys/src/9/mips/fns.h
174,175c
int	streamclose(Chan*);
int	streamclose1(Stream*);
.
151d
53c
void	error(int);
void	errors(char*);
.
51a
int	eqqid(Qid, Qid);
.
36c
void	devdir(Chan*, Qid, char*, long, long, Dir*);
.
## diffname power/fns.h 1990/1211
## diff -e /n/bootesdump/1990/11211/sys/src/9/mips/fns.h /n/bootesdump/1990/1211/sys/src/9/mips/fns.h
164a
void	setup(Proc*);
.
157a
void	save(uchar*, int);
.
154a
void	restore(Proc*, uchar*);
.
83a
void	invalidateu(void);
.
17a
void	clearmmucache(void);
.
11a
void	checkalarms(void);
.
## diffname power/fns.h 1990/1212
## diff -e /n/bootesdump/1990/1211/sys/src/9/mips/fns.h /n/bootesdump/1990/1212/sys/src/9/mips/fns.h
214a

/*
 *  no external state to save on the SGI
 */
#define procsetup(x)
#define procsave(x,y)
#define procrestore(x,y)
.
170d
162d
158d
69c
void	freepage(Orig*, int);
.
60c
int	fault(ulong, int);
void	faultmips(Ureg*, int, int);
.
## diffname power/fns.h 1990/1214
## diff -e /n/bootesdump/1990/1212/sys/src/9/mips/fns.h /n/bootesdump/1990/1214/sys/src/9/mips/fns.h
219a

#define USED(x) if(x)
#define SET(x) x = 0
.
## diffname power/fns.h 1990/1226
## diff -e /n/bootesdump/1990/1214/sys/src/9/mips/fns.h /n/bootesdump/1990/1226/sys/src/9/mips/fns.h
58a
void	execpc(ulong);
.
## diffname power/fns.h 1990/1228
## diff -e /n/bootesdump/1990/1226/sys/src/9/mips/fns.h /n/bootesdump/1990/1228/sys/src/9/mips/fns.h
93a
void	lanceconfig(void*, void*, void*, void*, int, void*, uchar*);
.
## diffname power/fns.h 1990/1229
## diff -e /n/bootesdump/1990/1228/sys/src/9/mips/fns.h /n/bootesdump/1990/1229/sys/src/9/mips/fns.h
196a
Block	*tolance(Block*, int);
.
99c
void	lancepktmem(ushort**, ushort**, int);
void	lancereset(void);
.
94,95c
void	lancectlmem(ushort**, ushort**, int*, int);
void	lanceeaddr(uchar*);
.
## diffname power/fns.h 1990/1231
## diff -e /n/bootesdump/1990/1229/sys/src/9/mips/fns.h /n/bootesdump/1990/1231/sys/src/9/mips/fns.h
99,100c
void	lancesetup(Lance*);
.
94,96d
## diffname power/fns.h 1991/0115
## diff -e /n/bootesdump/1990/1231/sys/src/9/mips/fns.h /n/bootesdump/1991/0115/sys/src/9/mips/fns.h
222a
#define	flushvirt()
.
182a
void	streaminit0(void);
.
## diffname power/fns.h 1991/0118
## diff -e /n/bootesdump/1991/0115/sys/src/9/mips/fns.h /n/bootesdump/1991/0118/sys/src/9/mips/fns.h
218c
#define procsetup(p)	((p)->fpstate = FPinit)
.
## diffname power/fns.h 1991/0209
## diff -e /n/bootesdump/1991/0201/sys/src/9/mips/fns.h /n/bootesdump/1991/0209/sys/src/9/power/fns.h
122a
void	notify(Ureg*);
.
87c
void	intr(Ureg*);
.
13c
void	clock(Ureg*);
.
3a
int	anyready(void);
.
## diffname power/fns.h 1991/0312
## diff -e /n/bootesdump/1991/0209/sys/src/9/power/fns.h /n/bootesdump/1991/0312/sys/src/9/power/fns.h
226a
#define	flushpage(x)
.
## diffname power/fns.h 1991/0314
## diff -e /n/bootesdump/1991/0312/sys/src/9/power/fns.h /n/bootesdump/1991/0314/sys/src/9/power/fns.h
160c
void	restfpregs(FPsave*, ulong);
.
63a
ulong	fcr31(void);
.
## diffname power/fns.h 1991/0325
## diff -e /n/bootesdump/1991/0314/sys/src/9/power/fns.h /n/bootesdump/1991/0325/sys/src/9/power/fns.h
209c
void	*vmemchr(void*, int, int);
.
189c
Stream	*streamnew(ushort, ushort, ushort, Qinfo*, int);
.
175c
uchar	*smap(int, uchar*);
.
173c
char	*skipslash(char*);
.
147c
Queue	*pushq(Stream*, Qinfo*);
.
130c
Block	*padb(Block*, int);
.
123c
Noifc	*nonetnewifc(Queue*, Stream*, int, int, int, void (*)(Noconv*, char*));
.
66c
Chan	*fdtochan(int, int);
.
43c
Chan	*devopen(Chan*, int, Dirtab*, int, Devgen*);
.
## diffname power/fns.h 1991/0328
## diff -e /n/bootesdump/1991/0325/sys/src/9/power/fns.h /n/bootesdump/1991/0328/sys/src/9/power/fns.h
121,124d
## diffname power/fns.h 1991/0411
## diff -e /n/bootesdump/1991/0328/sys/src/9/power/fns.h /n/bootesdump/1991/0411/sys/src/9/power/fns.h
189c
long	stringread(Chan*, void*, long, char*, ulong);
.
## diffname power/fns.h 1991/0414
## diff -e /n/bootesdump/1991/0411/sys/src/9/power/fns.h /n/bootesdump/1991/0414/sys/src/9/power/fns.h
72a
void	freechan(Chan*);
.
## diffname power/fns.h 1991/0419
## diff -e /n/bootesdump/1991/0414/sys/src/9/power/fns.h /n/bootesdump/1991/0419/sys/src/9/power/fns.h
38a
Chan	*devclwalk(Chan*, char*);
.
## diffname power/fns.h 1991/0424
## diff -e /n/bootesdump/1991/0419/sys/src/9/power/fns.h /n/bootesdump/1991/0424/sys/src/9/power/fns.h
143a
Block	*pullup(Block *, int);
.
6a
int	blen(Block *);
int	bround(Block *, int);
.
## diffname power/fns.h 1991/0425
## diff -e /n/bootesdump/1991/0424/sys/src/9/power/fns.h /n/bootesdump/1991/0425/sys/src/9/power/fns.h
209a
void	vector0(void);
.
149a
void	putstlb(ulong, ulong);
.
## diffname power/fns.h 1991/0428
## diff -e /n/bootesdump/1991/0425/sys/src/9/power/fns.h /n/bootesdump/1991/0428/sys/src/9/power/fns.h
219,231d
217d
214,215d
212c
void	vector80(void);
.
210d
200,208c
Block*	tolance(Block*, int);
void	touser(void*);
.
198a
void	sysloginit(void);
.
182,197d
175,180c
uchar*	smap(int, uchar*);
.
164,172d
159,162d
153,157d
150a
void	putstrn(char*, long);
.
148,149d
143,146c
Block*	prepend(Block*, int);
void	prflush(void);
#define procsetup(p)	((p)->fpstate = FPinit)
#define procsave(x,y)
#define procrestore(x,y)
Block*	pullup(Block *, int);
.
129,141d
127d
125d
105,122d
102a
void	launchinit(void);
.
98,99c
void	intr(Ureg*);
.
96d
91,94d
88,89d
86d
73,83c
#define	flushpage(x)
#define	flushvirt()
.
68,71d
63,65d
55,61d
34,48d
28a
void	confprint(void);
.
26,27d
23,24c
void	clockinit(void);
.
9,21d
1,5c
#include "../port/portfns.h"

.
## diffname power/fns.h 1991/0507
## diff -e /n/bootesdump/1991/0428/sys/src/9/power/fns.h /n/bootesdump/1991/0507/sys/src/9/power/fns.h
51d
4,5d
## diffname power/fns.h 1991/0607
## diff -e /n/bootesdump/1991/0507/sys/src/9/power/fns.h /n/bootesdump/1991/0607/sys/src/9/power/fns.h
60,61d
55a
#define	screenputs
.
43d
38d
31d
16,19c
void	duartslave(void);
.
10,13c
void	duartspecial(int, IOQ*, IOQ*, int);
int	duartactive(void);
void	duartenable0(void);
.
## diffname power/fns.h 1991/0705
## diff -e /n/bootesdump/1991/0607/sys/src/9/power/fns.h /n/bootesdump/1991/0705/sys/src/9/power/fns.h
53a
void	sysloginit(void);
void	syslog(char*, int);
.
38a
void	printslave(void);
.
27a
void	kbdchar(int);
.
25c
void	icflush(void *, ulong);
.
20c
#define	flushpage(s)	icflush((void*)(s), BY2PG)
.
15a
void	duartspecial(int, IOQ*, IOQ*, int);
void	duartxmit(int);
.
14a
void	duartreset(void);
.
10c
int	conschar(void);
void	dcflush(void*, ulong);
.
## diffname power/fns.h 1991/0726
## diff -e /n/bootesdump/1991/0705/sys/src/9/power/fns.h /n/bootesdump/1991/0726/sys/src/9/power/fns.h
28a
ulong	getcallerpc(void);
.
## diffname power/fns.h 1991/1007
## diff -e /n/bootesdump/1991/0726/sys/src/9/power/fns.h /n/bootesdump/1991/1007/sys/src/9/power/fns.h
25d
## diffname power/fns.h 1991/1011
## diff -e /n/bootesdump/1991/1007/sys/src/9/power/fns.h /n/bootesdump/1991/1011/sys/src/9/power/fns.h
32a
void	kproftimer(ulong);
.
## diffname power/fns.h 1991/1110
## diff -e /n/bootesdump/1991/1011/sys/src/9/power/fns.h /n/bootesdump/1991/1110/sys/src/9/power/fns.h
57a
void	setregisters(Ureg*, char*, char*, int);
.
## diffname power/fns.h 1991/1111
## diff -e /n/bootesdump/1991/1110/sys/src/9/power/fns.h /n/bootesdump/1991/1111/sys/src/9/power/fns.h
58d
## diffname power/fns.h 1992/0101
## diff -e /n/bootesdump/1991/1111/sys/src/9/power/fns.h /n/bootesdump/1992/0101/sys/src/9/power/fns.h
71a
#define	kmapperm(x)	kmap(x)
.
## diffname power/fns.h 1992/0122
## diff -e /n/bootesdump/1992/0101/sys/src/9/power/fns.h /n/bootesdump/1992/0122/sys/src/9/power/fns.h
47,48c
#define procsave(p)
#define procrestore(p)
.
## diffname power/fns.h 1992/0222
## diff -e /n/bootesdump/1992/0122/sys/src/9/power/fns.h /n/bootesdump/1992/0222/sys/src/9/power/fns.h
28c
ulong	getcallerpc(void*);
.
## diffname power/fns.h 1992/0610
## diff -e /n/bootesdump/1992/0222/sys/src/9/power/fns.h /n/bootesdump/1992/0610/sys/src/9/power/fns.h
22a
void	firmware(int);
.
## diffname power/fns.h 1992/0622
## diff -e /n/bootesdump/1992/0610/sys/src/9/power/fns.h /n/bootesdump/1992/0622/sys/src/9/power/fns.h
73a
#define KADDR(a)	((void*)((ulong)(a)|KZERO))
#define PADDR(a)	((ulong)(a)&~KZERO)
.
## diffname power/fns.h 1992/0629
## diff -e /n/bootesdump/1992/0622/sys/src/9/power/fns.h /n/bootesdump/1992/0629/sys/src/9/power/fns.h
39a
int	muxlock(int*, int*);
.
## diffname power/fns.h 1992/0802
## diff -e /n/bootesdump/1992/0629/sys/src/9/power/fns.h /n/bootesdump/1992/0802/sys/src/9/power/fns.h
25a
int	fptrap(Ureg*, ulong);
.
## diffname power/fns.h 1992/1015
## diff -e /n/bootesdump/1992/0802/sys/src/9/power/fns.h /n/bootesdump/1992/1015/sys/src/9/power/fns.h
73a
#define	screenupdate(a)
.
## diffname power/fns.h 1992/1030
## diff -e /n/bootesdump/1992/1015/sys/src/9/power/fns.h /n/bootesdump/1992/1030/sys/src/9/power/fns.h
74d
## diffname power/fns.h 1992/1125
## diff -e /n/bootesdump/1992/1030/sys/src/9/power/fns.h /n/bootesdump/1992/1125/sys/src/9/power/fns.h
59c
#define	screenputs syslog
.
11a
void	debugger(void*);
.
## diffname power/fns.h 1992/1129
## diff -e /n/bootesdump/1992/1125/sys/src/9/power/fns.h /n/bootesdump/1992/1129/sys/src/9/power/fns.h
27c
void	fptrap(Ureg*);
.
## diffname power/fns.h 1992/1217
## diff -e /n/bootesdump/1992/1129/sys/src/9/power/fns.h /n/bootesdump/1992/1217/sys/src/9/power/fns.h
60a
void	scsiintr(int);
.
## diffname power/fns.h 1993/0116
## diff -e /n/bootesdump/1992/1217/sys/src/9/power/fns.h /n/bootesdump/1993/0116/sys/src/9/power/fns.h
41a
#define	mmunewpage(x)
.
## diffname power/fns.h 1993/0501
## diff -e /n/bootesdump/1993/0116/sys/src/9/power/fns.h /n/fornaxdump/1993/0501/sys/src/brazil/power/fns.h
80a
Page*	lkpage(Segment*, ulong);
void	lkpgfree(Page*);
.
77c
#define	waserror()	setlabel(&up->errlab[up->nerrlab++])
.
54a
void	putcontext(int);
.
42d
## diffname power/fns.h 1993/0806
## diff -e /n/fornaxdump/1993/0501/sys/src/brazil/power/fns.h /n/fornaxdump/1993/0806/sys/src/brazil/power/fns.h
61c
#define	screenputs(a, b)
.
34a
int	iprint(char*, ...);
.
19c
void	duartspecial(int, int, Queue**, Queue**, int (*)(Queue*, int));
.
12d
## diffname power/fns.h 1993/0812
## diff -e /n/fornaxdump/1993/0806/sys/src/brazil/power/fns.h /n/fornaxdump/1993/0812/sys/src/brazil/power/fns.h
82a
#define vcacheinval(s)
.
## diffname power/fns.h 1993/1124
## diff -e /n/fornaxdump/1993/0812/sys/src/brazil/power/fns.h /n/fornaxdump/1993/1124/sys/src/brazil/power/fns.h
66a
long	syscall(Ureg*);
.
4a
void	clock(Ureg*);
.
## diffname power/fns.h 1993/1216
## diff -e /n/fornaxdump/1993/1124/sys/src/brazil/power/fns.h /n/fornaxdump/1993/1216/sys/src/brazil/power/fns.h
2a
#define affinity(x) m
.
## diffname power/fns.h 1994/0725
## diff -e /n/fornaxdump/1993/1216/sys/src/brazil/power/fns.h /n/fornaxdump/1994/0725/sys/src/brazil/power/fns.h
4a
#define	balance(x) m
.
## diffname power/fns.h 1994/0728
## diff -e /n/fornaxdump/1994/0725/sys/src/brazil/power/fns.h /n/fornaxdump/1994/0728/sys/src/brazil/power/fns.h
5d
3d
## diffname power/fns.h 1995/0108
## diff -e /n/fornaxdump/1994/0728/sys/src/brazil/power/fns.h /n/fornaxdump/1995/0108/sys/src/brazil/power/fns.h
27a
ulong	getstatus(void);
.
## diffname power/fns.h 1997/0220
## diff -e /n/fornaxdump/1995/0108/sys/src/brazil/power/fns.h /n/emeliedump/1997/0220/sys/src/brazil/power/fns.h
86a
#define coherence()
.
## diffname power/fns.h 1997/0327 # deleted
## diff -e /n/emeliedump/1997/0220/sys/src/brazil/power/fns.h /n/emeliedump/1997/0327/sys/src/brazil/power/fns.h
1,87d
