## diffname ss/screen.h 1991/0708
## diff -e /dev/null /n/bootesdump/1991/0708/sys/src/9/slc/screen.h
0a
typedef struct Mouseinfo	Mouseinfo;
typedef struct Cursorinfo	Cursorinfo;

struct Mouseinfo{
	/*
	 * First three fields are known in some l.s's
	 */
	int	dx;		/* interrupt-time delta */
	int	dy;
	int	track;		/* update cursor on screen */
	Mouse;
	int	changed;	/* mouse structure changed since last read */
	Rendez	r;
	int	newbuttons;	/* interrupt time access only */
	int	clock;		/* check mouse.track on RTE */
};

struct Cursorinfo{
	Cursor;
	Lock;
	int	visible;	/* on screen */
	Rectangle r;		/* location */
};


extern Mouseinfo	mouse;
extern Cursorinfo	cursor;

extern void		mouseupdate(int);
.
## diffname ss/screen.h 1991/0710
## diff -e /n/bootesdump/1991/0708/sys/src/9/slc/screen.h /n/bootesdump/1991/0710/sys/src/9/slc/screen.h
29a
#define kbitblt 	gbitblt
#define ubitblt 	gbitblt
.
## diffname ss/screen.h 1991/1225
## diff -e /n/bootesdump/1991/0710/sys/src/9/slc/screen.h /n/bootesdump/1991/1225/sys/src/9/slc/screen.h
30,31d
## diffname ss/screen.h 1992/1010
## diff -e /n/bootesdump/1992/0807/sys/src/9/slc/screen.h /n/bootesdump/1992/1010/sys/src/9/ss/screen.h
29a

#define	hwscreenwrite(a, b)
.
## diffname ss/screen.h 1992/1104
## diff -e /n/bootesdump/1992/1010/sys/src/9/ss/screen.h /n/bootesdump/1992/1104/sys/src/9/ss/screen.h
31a

#define mbbpt(x)
#define mbbrect(x)
#define screenupdate()
#define mousescreenupdate()
.
## diffname ss/screen.h 1992/1107
## diff -e /n/bootesdump/1992/1104/sys/src/9/ss/screen.h /n/bootesdump/1992/1107/sys/src/9/ss/screen.h
21a
	int	disable;	/* from being used */
.
## diffname ss/screen.h 1993/0225
## diff -e /n/bootesdump/1992/1107/sys/src/9/ss/screen.h /n/bootesdump/1993/0225/sys/src/9/ss/screen.h
12c
	ulong	counter;	/* increments every update */
	ulong	lastcounter;	/* value when /dev/mouse read */
.
## diffname ss/screen.h 1993/0226
## diff -e /n/bootesdump/1993/0225/sys/src/9/ss/screen.h /n/bootesdump/1993/0226/sys/src/9/ss/screen.h
1,30d
## diffname ss/screen.h 1993/0501 # deleted
## diff -e /n/bootesdump/1993/0226/sys/src/9/ss/screen.h /n/fornaxdump/1993/0501/sys/src/brazil/ss/screen.h
1,8d
