## diffname ss/segment.h 1991/0706
## diff -e /dev/null /n/bootesdump/1991/0706/sys/src/9/slc/segment.h
0a
/*
 * Attach segment types
 */

typedef struct Physseg Physseg;
struct Physseg
{
	ulong	attr;			/* Segment attributes */
	char	*name;			/* Attach name */
	ulong	pa;			/* Physical address */
	ulong	size;			/* Maximum segment size in pages */
	Page	*(*pgalloc)(ulong);	/* Allocation if we need it */
	void	(*pgfree)(Page*);
}physseg[] = {
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 	0 },
	{ SG_PHYSICAL,	"kmem",		KZERO,	SEGMAXSIZE,	0,	0 },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0,	0 },
	{ 0,		0,		0,	0,		0,	0 },
};
.
## diffname ss/segment.h 1993/0120
## diff -e /n/bootesdump/1992/0807/sys/src/9/slc/segment.h /n/bootesdump/1993/0120/sys/src/9/ss/segment.h
12c
	Page	*(*pgalloc)(Segment*, ulong);	/* Allocation if we need it */
.
## diffname ss/segment.h 1993/0216
## diff -e /n/bootesdump/1993/0120/sys/src/9/ss/segment.h /n/bootesdump/1993/0216/sys/src/9/ss/segment.h
5,14c
Physseg physseg[] = {
.
## diffname ss/segment.h 1993/0501 # deleted
## diff -e /n/bootesdump/1993/0216/sys/src/9/ss/segment.h /n/fornaxdump/1993/0501/sys/src/brazil/ss/segment.h
1,10d
